unit Dcu1;

{$MODE Delphi}

interface
{$WARNINGS OFF}

uses
  LCLIntf, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  {Consts,} ExtCtrls, Registry, Types, LCLType;

type
  TPercent = 0..100;
  T4Dir = (dirNone, dirLeft, dirRight, dirUp, dirDown);
  TAutoBool = (abFalse, abTrue, abAuto);
  TThreeBool = (tbFalse, tbTrue, tbThirdValue);
  TProtectionMode = (pmProtect, pmUnProtect, pmCheckProtection);
  TKS = (ksNumLock, ksCapsLock, ksScrollLock);
  TKSChange = (kscDisable, kscEnable, kscToggle, kscRandom);
  TBytePoint = record
    X, Y: Byte;
  end;
  PBytePoint = ^TBytePoint;

function ApplicationHasParameter(ParamText: String): Integer;
function GoOut(Number: Integer; DivNumber: Integer): Boolean;
function Medelvarde(Numbers: array of Longword): Real;
function RealToStr(R: Real): String;
function StrToReal(S: String): Real;
//function PCharToStr(P: PChar): String;
function StrToBigLetterStr(S: String): String;

function FileHasBeenUpdated(const Filename: String; const AddIfNotInReg, WriteNewAge: Boolean; var IsInReg: TAutoBool): Boolean;
procedure Crypts(Source, Destination: TStringList; Flytt: Word); overload;
procedure DECrypts(Source, Destination: TStringList; Flytt: Word); overload;
procedure Crypts(Source, Destination: TStrings; Flytt: Word); overload;
procedure DECrypts(Source, Destination: TStrings; Flytt: Word); overload;
function Replace(const S, SearchFor, ReplaceWith: String; const CaseSensetive: Boolean = False): String;
function Randomise(const Min, Max: Longword; const DoRandomize: Boolean = False): Longword;
function Sgd(a, b: Longint): Longint;
function Crypt(const S: String; const Flytt: Word): String;
function DECrypt(const S: String; const Flytt: Word): String;
function GetListMarkedInt(const List: TListbox): Integer;
function Seltext(const List: TListbox): string;
procedure Delay(const Sec, MSec: Cardinal);
procedure DelayLock(const Sec, MSec: Cardinal);
function GetAveCharSize(Canvas: TCanvas): TPoint;

function GetNumberOf(Text: String; const SearchFor: String): Integer;

function GetTextBetween(const Text: String; const After, Before: String; const AddAfterBreaker: Boolean = False; const AddBeforeBreaker: Boolean = False): String;
function GetTextBefore(const Text: String; const Breaker: String; const AddBreaker: Boolean = False): String;
function GetTextAfter(const Text: String; const Breaker: String; const AddBreaker: Boolean = False): String;

function SetTextBefore(const Text, Breaker, SetTo: String): String;
function SetTextAfter(const Text, Breaker, SetTo: String): String;
function SetTextBetween(const Text, After, Before, SetTo: String): String;

procedure DeleteTextBetween(var Text: String; const After, Before: String; const DeleteAfterBreaker: Boolean = False; const DeleteBeforeBreaker: Boolean = False);
procedure DeleteTextBefore(var Text: String; const Breaker: String; const DeleteBreaker: Boolean = False);
procedure DeleteTextAfter(var Text: String; const Breaker: String; const DeleteBreaker: Boolean = False);

function RandomColor: TColor;

function ListGetAt(List: String; const Position: Integer; const Delimiter: String): String;
function ListSetAt(List: String; Position: Integer; Value: String; Delimiter: String): String;
function ListLen(List: String; Delimiter: String): Integer;
function ListPos(List, Delimiter, Find: String): Integer;


function CursorXPos: LongInt;
function CursorYPos: LongInt;

function Appdir: String;

function CharsToInteger(const Value: String): Int64;
function IntegerToChars(Value: Integer): String;

function RoundInt(Value: Integer; const ToNearnestValue: Integer): Integer;
function RoundRand(E: Extended; const Decimals: Integer = 10): Integer;
function MGN(var A, B: Integer): Integer;
function Biggest(const Values: array of Integer): Integer;
function Smallest(const Values: array of Integer): Integer;

function XYInt(const X, Y, Size: Integer): Integer;
function IntXY(const I, Size: Integer): TPoint;

function DECryptC1(const S: String; OwnCode: String; const Log: Boolean): String;
function CryptC1(const S: String; OwnCode: String; const Log: Boolean): String;

function SumOrd(const S: String): Byte;
function IntPower(const Base: Extended; const Exponent: Integer): Extended;
function Diff(const I, J: Integer): Integer;

function BytesToWord(B1, B2: Byte): Word;
function WordToBytes(W: Word): TBytePoint;

function BoolToChr(B: Boolean): Char;
function ChrToBool(C: Char): Boolean;

function AvarageAdd(const Old, NewValue: Real; var NumberOfValues: Integer): Real;
function AvarageReplace(const Old, NewValue: Real; var NumberOfValues: Integer): Real;
function DirOpposite(const Dir: T4Dir): T4Dir;
function DirLR_or_UD(const A, B: T4Dir): Boolean;

function StringToHexValues(const S: String): String;
function BPToStr(const BP: TBytePoint; const Seperator: String = ', '): String;
function BP(const X, Y: Integer): TBytePoint;
function PointToBPTile(const Pos: TPoint; const Size: Byte): TBytePoint;
function BPTileToPoint(const Pos: TBytePoint; const Size: Byte): TPoint;
function RectSorted(const OnePos: TPoint; const TwoPos: TPoint): TRect;
function BPSort(var TopLeft, BottomRight: TBytePoint): Boolean;
function BPTileToRect(const Pos: TBytePoint; const Size: Byte): TRect;

function IntToStrLen(const Int: Integer; const MinLength: Byte): String;
function SelectDir: String;
function IndexOfValue(const Value: Integer; const Values: array of Integer; const Default: Integer = -1): Integer;
function IndexOfValueMOD(const Value: Integer; const Values: array of Integer; const Default: Integer = -1): Integer;
function IndexOfValueAND(const Value: Integer; const Values: array of Integer; const Default: Integer = -1): Integer;

implementation

function IndexOfValue(const Value: Integer; const Values: array of Integer; const Default: Integer = -1): Integer;
var
  I: Integer;
begin
  Result:=Default;
  for I:=Low(Values) to High(Values) do
  if Value = Values[I] then
  begin
    Result:=I;
    Break;
  end;
end;

function IndexOfValueMOD(const Value: Integer; const Values: array of Integer; const Default: Integer = -1): Integer;
var
  I: Integer;
begin
  Result:=Default;
  for I:=Low(Values) to High(Values) do
  if Value mod Values[I] = 0 then
  begin
    Result:=I;
    Break;
  end;
end;

function IndexOfValueAND(const Value: Integer; const Values: array of Integer; const Default: Integer = -1): Integer;
var
  I: Integer;
begin
  Result:=Default;
  for I:=Low(Values) to High(Values) do
  if Value and Values[I] <> 0 then
  begin
    Result:=I;
    Break;
  end;
end;

function IntToStrLen(const Int: Integer; const MinLength: Byte): String;
begin
  Result:=IntToStr(Int);
  while Length(Result) < MinLength do Result:='0'+Result;
end;

function SelectDir: String;
var
  Dir: string;
begin
//  Dir := 'C:\Windows';
  if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt], 0) then
    Result := Dir;
end;

function BPTileToRect(const Pos: TBytePoint; const Size: Byte): TRect;
var
  P2: TPoint;
begin
  P2:=BPTileToPoint(Pos, Size);
  Inc(P2.X, Size);
  Inc(P2.Y, Size);
  Result:=Rect(Pos.X, Pos.Y, P2.X, P2.Y);
end;

function RectSorted(const OnePos: TPoint; const TwoPos: TPoint): TRect;
begin
  if OnePos.X <= TwoPos.X then
   if OnePos.Y <= TwoPos.Y then
     Result:=Rect(OnePos.X, OnePos.Y, TwoPos.X, TwoPos.Y)
   else
     Result:=Rect(OnePos.X, TwoPos.Y, TwoPos.X, OnePos.Y)
  else
   if OnePos.Y <= TwoPos.Y then
     Result:=Rect(TwoPos.X, OnePos.Y, OnePos.X, TwoPos.Y)
   else
     Result:=Rect(TwoPos.X, TwoPos.Y, OnePos.X, OnePos.Y);
end;

function BPSort(var TopLeft, BottomRight: TBytePoint): Boolean;
var
  Temp: Byte;
begin
  if TopLeft.X > BottomRight.X then
  begin
    Temp:=TopLeft.X;
    TopLeft.X:=BottomRight.X;
    BottomRight.X:=Temp;
    Result:=True;
  end;
  if TopLeft.Y > BottomRight.Y then
  begin
    Temp:=TopLeft.Y;
    TopLeft.Y:=BottomRight.Y;
    BottomRight.Y:=Temp;
    Result:=True;
  end;
end;

function PointToBPTile(const Pos: TPoint; const Size: Byte): TBytePoint;
begin
  Result:=BP((Pos.X) div Size+1,
             (Pos.Y) div Size+1);
//  P.X:=(CX * 32) - (SX * 32) - 16;
//  P.Y:=(CY * 32) - (SY * 32) - 16;
end;

function BPTileToPoint(const Pos: TBytePoint; const Size: Byte): TPoint;
begin
  Result:=Point((Pos.X-1)*Size,(Pos.Y-1)*Size);
//  P.X:=(CX * 32) - (SX * 32) - 16;
//  P.Y:=(CY * 32) - (SY * 32) - 16;
end;

function BP(const X, Y: Integer): TBytePoint;
begin
  Result.X:=X;
  Result.Y:=Y;
end;

function BPToStr(const BP: TBytePoint; const Seperator: String = ', '): String;
begin
  Result:=IntToStr(BP.X) + Seperator + IntToStr(BP.Y);
end;

function StringToHexValues(const S: String): String;
var
  I: Integer;
  B: Byte;
begin
//  SetLength(Result, Length(S)*2);// Speed hint on some page, do not use Result:=Result + x;
  Result:='';
  for I:=1 to Length(S) do
  begin
    B:=Ord(S[I]);
// turn byte value into hex and set in string
    Insert(IntToHex(B, 2), Result, I*2-1);
//    Result[I*2-1]:=B;
//    Result[I*2]:=B;
  end;
end;

function DirOpposite(const Dir: T4Dir): T4Dir;
begin
  Result:=dirNone;
  case Dir of
    dirLeft: Result:=dirRight;
    dirRight: Result:=dirLeft;
    dirUp: Result:=dirDown;
    dirDown: Result:=dirUp;
  end;
end;

function DirLR_or_UD(const A, B: T4Dir): Boolean;
begin
  Result:=(A = DirOpposite(B)) or (A = B);
  if (A = dirNone) or (B = dirNone) then Result:=False;
end;

function AvarageAdd(const Old, NewValue: Real; var NumberOfValues: Integer): Real;
begin
  Result:=((Old*NumberOfValues) + NewValue) / (NumberOfValues+1);
  Inc(NumberOfValues);
end;

function AvarageReplace(const Old, NewValue: Real; var NumberOfValues: Integer): Real;
begin
  Result:=((Old*NumberOfValues) + NewValue - Old) / NumberOfValues;
  Inc(NumberOfValues);
end;

function BoolToChr(B: Boolean): Char;
begin
  if B then Result:='1'
  else Result:='0';
end;

function ChrToBool(C: Char): Boolean;
begin
  if C = '1' then Result:=True
  else Result:=False;
end;

function BytesToWord(B1, B2: Byte): Word;
begin
  Result:=B1*256+B2;
end;

function WordToBytes(W: Word): TBytePoint;
begin
  Result.X:=W div 256;
  Result.Y:=W mod 256;
end;

function SumOrd(const S: String): Byte;
var
  I: Integer;
begin
  Result:=0;
  for I:=1 to Length(S) do Result:=Result + Ord(S[I]);
  Result:=Result mod 256;
end;

function IntPower(const Base: Extended; const Exponent: Integer): Extended;
asm
        mov     ecx, eax
        cdq
        fld1                      { Result := 1 }
        xor     eax, edx
        sub     eax, edx          { eax := Abs(Exponent) }
        jz      @@3
        fld     Base
        jmp     @@2
@@1:    fmul    ST, ST            { X := Base * Base }
@@2:    shr     eax,1
        jnc     @@1
        fmul    ST(1),ST          { Result := Result * X }
        jnz     @@1
        fstp    st                { pop X from FPU stack }
        cmp     ecx, 0
        jge     @@3
        fld1
        fdivrp                    { Result := 1 / Result }
@@3:
        fwait
end;

function Diff(const I, J: Integer): Integer;
begin
  if I > J then Result:=I - J
  else Result:=J - I;
end;

function CryptC1(const S: String; OwnCode: String; const Log: Boolean): String;
var
  I, L, OrdC, CP, PrevC, NextO: Integer;
  SCode, SS, Res: Integer;
begin
  Result:='';
  L:=Length(S);
  SCode:=SumOrd(OwnCode);
  while Length(OwnCode) < L do OwnCode:=OwnCode + OwnCode;
  SS:=SumOrd(S);
  for I:=1 to L do
  begin
    OrdC:=Ord(S[I]);
    CP:=Ord(OwnCode[I]);
    if I > 1 then PrevC:=Ord(Result[I - 1])
    else PrevC:=0;
    if I < L then NextO:=Ord(S[I + 1])
    else NextO:=0;
    Res:=SS + SCode + OrdC + CP + PrevC + NextO + I + L;
    while Res > 255 do Dec(Res, 255);

    Result:=Result + Chr(Res);
  end;
  if SS + SCode > 255 then Result:=Result + Chr(SS + SCode - 1)
  else Result:=Result + Chr(SS + SCode);
end;

function DECryptC1(const S: String; OwnCode: String; const Log: Boolean): String;
var
  I, L, OrdC, CP, PrevC, NextO: Integer;
  Sum, SumCode, Res: Integer;
begin
  Result:='';
  L:=Length(S)-1;
  SumCode:=SumOrd(OwnCode);
  while Length(OwnCode) < L do OwnCode:=OwnCode + OwnCode;
  Sum:=Ord(S[L+1]) - SumCode;
  if Sum < 0 then Inc(Sum, 255);
  for I:=L downto 1 do
  begin
    OrdC:=Ord(S[I]);
    CP:=Ord(OwnCode[I]);
    if I > 1 then PrevC:=Ord(S[I - 1])
    else PrevC:=0;
    if I < L then NextO:=Ord(Result[1])
    else NextO:=0;
    Res:=OrdC - Sum - SumCode - CP - PrevC - NextO - I - L;
    while Res < 0 do Inc(Res, 255);

    Result:=Chr(Res) + Result;
  end;
end;

function XYInt(const X, Y, Size: Integer): Integer;
begin
  if X < Size then
  begin
    Result:=X;
    Inc(Result, Y*Size);
  end
  else Result:=-1;
end;

function IntXY(const I, Size: Integer): TPoint;
begin
  Result.X:=I mod Size;
  Result.Y:=I div Size;
end;

function GetNumberOf(Text: String; const SearchFor: String): Integer;
var
  I: Integer;
begin
  Result:=0;
  while Pos(SearchFor, Text) <> 0 do
  begin
    I:=Pos(SearchFor, Text);
    if I <> 0 then
    begin
      Inc(Result);
      Delete(Text, I, Length(SearchFor));
    end;
  end;
end;

function RoundInt(Value: Integer; const ToNearnestValue: Integer): Integer;
var
  C: Real;
begin
  Result:=(Value div ToNearnestValue) * ToNearnestValue;
  Value:=Value mod ToNearnestValue;
  C:=ToNearnestValue / 2;
  if Value >= C then Result:=Result + ToNearnestValue;
end;

function Biggest(const Values: array of Integer): Integer;
var
  I: Integer;
begin
  Result:=Low(Result);
  for I:=Low(Values) to High(Values) do
   if Values[I] > Result then Result:=Values[I];
end;

function Smallest(const Values: array of Integer): Integer;
var
  I: Integer;
begin
  Result:=High(Result);
  for I:=Low(Values) to Length(Values) do
   if Values[I] < Result then Result:=Values[I];
end;

function MGN(var A, B: Integer): Integer;
var
  I: Integer;
begin
  Result:=0;
  for I:=Smallest([A, B]) downto 2 do
  if (A mod I = 0) and (B mod I = 0) then
  begin
    A:=A div I;
    B:=B div I;
    Result:=I;
  end;
end;

function BoolsToString(const Bools: array of Boolean; const MakeChars: Boolean): String;// TEST
var
  I, J, K: Integer;
begin
  Result:='';
  J:=0;
  if MakeChars then
  begin
    for I:=1 to Length(Bools) do
    begin
      K:=I;
      while K > 8 do Dec(K, 8);
      if Bools[I - 1] then Inc(J, Trunc(IntPower(2, K - 1)));
      if I mod 8 = 0 then// make a char out of A[1..8}
      begin
        if J <> 0 then Result:=Result + Chr(J)
        else Showmessage('BOOLS TO STRING ERROR: NULL TERMINATOR!');
        J:=0;
      end;
    end;
    if J <> 0 then Result:=Result + Chr(J);
  end
  else for I:=1 to Length(Bools) do Result:=Result + IntToStr(Integer(Bools[I - 1]));
end;

function StringToBoolIntStr(const S: String; const FromChars: Boolean): String;// TEST
var
  I, J: Integer;
begin
  Result:='';
//  J:=0;
  if FromChars then
  begin
    for I:=1 to Length(S) do
     for J:=1 to 8 do
      if Ord(S[I]) and Trunc(IntPower(2, J - 1)) <> 0 then Result[(I - 1) * 8 + J - 1]:='1';
  end
//  else for I:=1 to Length(Bools) do Result:=Result + IntToStr(Integer(Bools[I - 1]));
end;

function CharsToInteger(const Value: String): Int64;
var
  I: Integer;
begin
  Result:=0;
  if Value = '' then Result:=2147483647
  else for I:=1 to Length(Value) do Inc(Result, Ord(Value[I]) * Trunc(IntPower(255, I - 1)));
end;

function IntegerToChars(Value: Integer): String;
var
  I, J: Int64;
  F: Integer;
begin
  Result:='';
  if Value <> 2147483647 then
  begin
    I:=0;
    J:=0;
    while I < Value do
    begin
      Inc(J);
      I:=Trunc(IntPower(255, J));
    end;
    Result:=Result + Chr(Value mod 255);
    Dec(Value, Value mod 255);
    for F:=2 to J do
    begin
      Result:=Result + Chr(Value div Trunc(IntPower(255, F - 1)));
      Dec(Value, Value div Trunc(IntPower(255, F - 1)));
    end;
  end;
end;

function Appdir: String;
begin
  Result:=ExtractFilePath(Application.ExeName);
end;

function CursorXPos: LongInt;
var
  P: TPoint;
begin
  GetCursorPos(P);
  Result:=P.X;
end;

function CursorYPos: LongInt;
var
  P: TPoint;
begin
  GetCursorPos(P);
  Result:=P.Y;
end;

function ListGetAt(List: String; const Position:Integer; const Delimiter: String): String;
var
  I, NP: Integer;
begin
  NP:=0;
  for I:=1 to Position do
  begin
    List:=Copy(List, NP, Length(List) - NP + 1);
    NP:=Pos(Delimiter, List) + Length(Delimiter);
//    NP:=Pos(Delimiter,List)+1;
    if I = Position then
    begin
      if Pos(Delimiter, List) = 0 then Break;
//      Delete(List, NP-1, Length(List)-(NP-2));
      Delete(List, NP - Length(Delimiter), Length(List));
    end;
  end;
  Result:=List;
end;
//    NP:=Pos(Delimiter,List)+1;
//      Delete(List, NP-1, Length(List)-(NP-2));
function ListSetAt(List: String; Position: Integer; Value: String; Delimiter: String): String;
var
  I, NP: integer;
  BegStr, EndStr: string;
begin


  NP:=0;
  BegStr:='';
  EndStr:='';
  for I:=1 to Position do
  begin
    if I > 1 then BegStr := BegStr + Copy(List, 0, NP-1);
    List:=Copy(List, NP, Length(List) - NP + 1);
    NP:=Pos(Delimiter, List) + Length(Delimiter);
//    NP:=Pos(Delimiter, List) + 1;
    if I = Position then
    begin
      if Pos(Delimiter, List) = 0 then break;
      EndStr:=Copy(List, NP - Length(Delimiter), Length(List));
    end;
  end;
  Result := BegStr+Value+EndStr;
end;

function ListLen(List: String; Delimiter: String): Integer;
begin
  Result := 1;
  while Pos(Delimiter, List) > 0 do
  begin
    Delete(List, 1, Pos(Delimiter, List) + Length(Delimiter));
    Result := Result + 1;
  end;
end;

function ListPos(List, Delimiter, Find: String): Integer;
var
  I: Integer;
begin
  Result:=0;
  for I:=1 to ListLen(List, Delimiter) do
   if ListGetAt(List, I, Delimiter) = Find then Result:=I;
end;

function RandomColor: TColor;
var
  R, G, B: Byte;
  C: TColor;
begin
  R:=Randomise(0, 255);
  G:=Randomise(0, 255);
  B:=Randomise(0, 255);
  C:=RGB(R, G, B);
  Result:=C;
end;

function ApplicationHasParameter(ParamText: String): Integer;
var
  I: Integer;
begin
  Result:=0;
  for I:=1 to ParamCount do if ParamStr(I) = ParamText then Result:=Result + 1;
end;

function SetTextBefore(const Text, Breaker, SetTo: String): String;
begin
  Result:=Text;
  DeleteTextBefore(Result, Breaker);
  Result:=SetTo + Result;
end;

function SetTextAfter(const Text, Breaker, SetTo: String): String;
begin
  Result:=Text;
  DeleteTextAfter(Result, Breaker);
  Result:=Result + SetTo;
end;

function SetTextBetween(const Text, After, Before, SetTo: String): String;
var
  S, E: Integer;
begin
  Result:=Text;
  S:=Pos(Before, Text);
  E:=Pos(After, GetTextAfter(Text, After));
  if (E <> 0) and (S <> 0) then
  begin
// search after breakers, delete text after breaker and add new text
    DeleteTextBetween(Result, After, Before);
    Insert(SetTo, Result, S - Length(Before) - 1);
  end;
end;

function GetTextBefore(const Text: String; const Breaker: String; const AddBreaker: Boolean = False): String;
begin
  Result:='';
  if Pos(Breaker, Text) <> 0 then
  begin
    Result:=Copy(Text, 1, Pos(Breaker, Text) - 1);
    if AddBreaker then Insert(Breaker, Result, Length(Result) + 1);
  end;
end;

function GetTextAfter(const Text: String; const Breaker: String; const AddBreaker: Boolean = False): String;
begin
  Result:='';
  if Pos(Breaker, Text) <> 0 then
  begin
    Result:=Copy(Text, Pos(Breaker, Text) + Length(Breaker), Length(Text) - Pos(Breaker, Text));
    if AddBreaker then Insert(Breaker, Result, 1);
  end;
end;

function GetTextBetween(const Text: String; const After, Before: String; const AddAfterBreaker: Boolean = False; const AddBeforeBreaker: Boolean = False): String;
begin
  Result:=GetTextBefore(GetTextAfter(Text, After), Before);
  if AddBeforeBreaker then Insert(Before, Result, Length(Result) + 1);
  if AddAfterBreaker then Insert(After, Result, 1);
end;

procedure DeleteTextBetween(var Text: String; const After, Before: String; const DeleteAfterBreaker: Boolean = False; const DeleteBeforeBreaker: Boolean = False);
begin
  if (Pos(After, Text) <> 0) and (Pos(Before, Text) <> 0) then
  begin
   Delete(Text, Pos(After, Text) + Length(After), Pos(Before, Text) - Pos(After, Text) - Length(Before) - 1);
    if DeleteAfterBreaker then Delete(Text, Pos(After, Text), Length(After));
    if DeleteBeforeBreaker then Delete(Text, Pos(Before, Text), Length(Before));
  end;
end;

procedure DeleteTextBefore(var Text: String; const Breaker: String; const DeleteBreaker: Boolean = False);
begin
  if Pos(Breaker, Text) <> 0 then
  begin
    Delete(Text, 1, Pos(Breaker, Text) - 1);
    if DeleteBreaker then Delete(Text, Pos(Breaker, Text), Length(Breaker));
  end;
end;

procedure DeleteTextAfter(var Text: String; const Breaker: String; const DeleteBreaker: Boolean = False);
begin
  if Pos(Breaker, Text) <> 0 then
  begin
    Delete(Text, Pos(Breaker, Text) + Length(Breaker), Length(Text) - Pos(Breaker, Text));
    if DeleteBreaker then Delete(Text, Pos(Breaker, Text), Length(Breaker));
  end;
end;

function GetAveCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;

function GoOut(Number: Integer; DivNumber: Integer): Boolean;
begin
  Result:=False;
  if Number mod DivNumber = 0 then Result:=True;
end;

procedure Delay(const Sec, MSec: Cardinal);
var
  I, S: Cardinal;
begin
  S:=Sec * 1000;
  I:=GetTickCount + S + MSec;
  while GetTickCount < I do Application.ProcessMessages;
end;

procedure DelayLock(const Sec, MSec: Cardinal);
var
  I, S: Cardinal;
begin
  S:=Sec * 1000;
  I:=GetTickCount + S + MSec;
  while GetTickCount < I do;
end;

function Seltext(const List: TListbox): string;
var
  nItem: Integer;
begin
  nItem:=List.Itemindex;
  if nItem >= 0 then Result:=List.Items[nItem]
  else Result:='';
end;

function GetListMarkedInt(const List: TListbox): Integer;
var
  nItem: Integer;
begin
  Result:=0;
  nItem:=List.Itemindex;
  if nItem >= 0 then Result:=nItem;
end;

procedure Crypts(Source, Destination: TStringList; Flytt: Word); overload;
var
  CurrentLetter, OldASCII, NewASCII, CurrentLine: Integer;
  CurrentChar: Char;
begin
  Destination.Clear;
  if Destination.Count < Source.Count then
  repeat
    Destination.Add('');// add Count
  until Destination.Count >= Source.Count;
  for CurrentLine:=0 to Source.Count - 1 do
  begin
    for CurrentLetter:=1 to Length(Source[CurrentLine]) do
    begin
      CurrentChar:=Source[CurrentLine][CurrentLetter];
      OldASCII:=Ord(CurrentChar);
      NewASCII:=OldASCII + Flytt;
      Destination[CurrentLine]:=Destination[CurrentLine] + Chr(NewASCII);
    end;
  end;
end;

procedure DECrypts(Source, Destination: TStringList; Flytt: Word); overload;
var
  CurrentLetter, OldASCII, NewASCII, CurrentLine: Integer;
  CurrentChar: Char;
begin
  Destination.Clear;
  if Destination.Count < Source.Count then
  repeat
    Destination.Add('');// add Count
  until Destination.Count >= Source.Count;
  for CurrentLine:=0 to Source.Count - 1 do
  begin
    for CurrentLetter:=1 to Length(Source[CurrentLine]) do
    begin
      CurrentChar:=Source[CurrentLine][CurrentLetter];
      OldASCII:=Ord(CurrentChar);
      NewASCII:=OldASCII - Flytt;
      Destination[CurrentLine]:=Destination[CurrentLine] + Chr(NewASCII);
    end;
  end;
end;

procedure Crypts(Source, Destination: TStrings; Flytt: Word); overload;
var
  CurrentLetter, OldASCII, NewASCII, CurrentLine: Integer;
  CurrentChar: Char;
begin
  Destination.Clear;
  if Destination.Count < Source.Count then
  repeat
    Destination.Add('');// add Count
  until Destination.Count >= Source.Count;
  for CurrentLine:=0 to Source.Count - 1 do
  begin
    for CurrentLetter:=1 to Length(Source[CurrentLine]) do
    begin
      CurrentChar:=Source[CurrentLine][CurrentLetter];
      OldASCII:=Ord(CurrentChar);
      NewASCII:=OldASCII + Flytt;
      Destination[CurrentLine]:=Destination[CurrentLine] + Chr(NewASCII);
    end;
  end;
end;

procedure DECrypts(Source, Destination: TStrings; Flytt: Word); overload;
var
  CurrentLetter, OldASCII, NewASCII, CurrentLine: Integer;
  CurrentChar: Char;
begin
  Destination.Clear;
  if Destination.Count < Source.Count then
  repeat
    Destination.Add('');// add Count
  until Destination.Count >= Source.Count;
  for CurrentLine:=0 to Source.Count - 1 do
  begin
    for CurrentLetter:=1 to Length(Source[CurrentLine]) do
    begin
      CurrentChar:=Source[CurrentLine][CurrentLetter];
      OldASCII:=Ord(CurrentChar);
      NewASCII:=OldASCII - Flytt;
      Destination[CurrentLine]:=Destination[CurrentLine] + Chr(NewASCII);
    end;
  end;
end;

function Crypt(const S: String; const Flytt: Word): String;
var
  I: Integer;
begin
  for I:=1 to Length(S) do Result:=Result + Chr(Ord(S[I]) + Flytt);
end;

function DECrypt(const S: String; const Flytt: Word): String;
var
  I: Integer;
begin
  for I:=1 to Length(S) do Result:=Result + Chr(Ord(S[I]) - Flytt);
end;

function Sgd(a, b: Longint): Longint;
var r: Integer;
begin
  r:=a mod b;
  while r <> 0 do
  begin
    a:=b;
    b:=r;
    r:=a mod b;
  end;
  Result:=b;
end;

function Randomise(const Min, Max: Longword; const DoRandomize: Boolean = False): Longword;
var randtal, rand2: Longword;
begin
  if DoRandomize then Randomize;
  if (Min <= Max) and (Max >= Min) then
  begin
    randtal:=(Max + 1) - Min;
    rand2:=random(randtal);
    Result:=rand2 + Min;
  end
  else Result:=0;
end;

function Medelvarde(Numbers: array of Longword): Real;
var sum, I, N: Longword;
    res: Real;
begin
  sum:=0;
  N:=0;
  for I:=Low(Numbers) to High (Numbers) do
  begin
    Inc(sum, Numbers[I]);
    Inc(N);
  end;
  res:=sum / N;
  Result:=res;
end;

function RoundRand(E: Extended; const Decimals: Integer = 10): Integer;
var
  B, X: Byte;
  I: Extended;
  Max: Integer;
  Negative: Boolean;
begin
  if E < 0 then
  begin
    Negative:=True;
    E:=-E;
  end
  else Negative:=False;
  I:=Frac(E);
  X:=0;
  while (Trunc(I) <> I) and ((X < Decimals) or (Decimals = -1)) do
  begin
    I:=I * 10;
    Inc(X);
  end;
  Max:=Trunc(IntPower(10, X));
  B:=Randomise(1, Max);
  if B <= I then Result:=Trunc(E) + 1
  else Result:=Trunc(E);
  if Negative then Result:=-Result;
end;

function RealToStr(R: Real): String;
var
  V: Variant;
begin
  V:=R;
  Result:=V;
end;

function StrToReal(S: String): Real;
var
  V: Variant;
begin
  V:=S;
  Result:=V;
end;

function PCharToStr(P: PChar): String;
begin
  Result:=StrPas(P);
end;

function StrToBigLetterStr(S: String): String;
var I: Integer;
  St: String;
begin
  for I:=0 to Length(S) do
  case St[i] of
    'a'..'z': St[I]:=UpCase(St[I]);
    '': St[I]:='';
    '': St[I]:='';
    '': St[I]:=''
  else;
  end;
  Result:=St;
end;

function Replace(const S, SearchFor, ReplaceWith: String; const CaseSensetive: Boolean = False): String;
begin
  if CaseSensetive then Result:=StringReplace(S, SearchFor, ReplaceWith, [rfReplaceAll])
  else Result:=StringReplace(S, SearchFor, ReplaceWith, [rfReplaceAll, rfIgnoreCase]);
end;

function FileHasBeenUpdated(const Filename: String; const AddIfNotInReg, WriteNewAge: Boolean; var IsInReg: TAutoBool): Boolean;
var
  R: TRegIniFile;
  CurrentAge, RegistredAge: Integer;
  Countinue: Boolean;
begin
  Countinue:=True;
  Result:=True;
  if Fileexists(Filename) then
  begin
    CurrentAge:=FileAge(Filename);
    R:=TRegIniFile.Create('Software\Zomis\UpdateCheck');
    if IsInReg = ABAuto then
    if R.ReadString(Filename, 'Age', 'NOT EXISTS (512946)') = 'NOT EXISTS (512946)' then
    begin
      if not AddIfNotInReg then Countinue:=False;
      IsInReg:=ABFalse;
    end
    else IsInReg:=ABTrue;

    if Countinue then
    begin
      RegistredAge:=R.ReadInteger(Filename, 'Age', 0);
      if CurrentAge > RegistredAge then Result:=True
      else Result:=False;
      if WriteNewAge then R.WriteInteger(Filename, 'Age', CurrentAge);
    end;
    R.Free;
  end
  else Showmessage('File not found: ' + Filename);
end;

{$WARNINGS ON}

initialization
  Randomize;
end.
