unit chunk_confs;

{$MODE Delphi}

interface

uses Files, files_c, rndtypes, main_h, misc_fromsource;

//xx_default_description: array [0..Pred(MAX_ELEMENT_NAME_LEN+1)] of char = '';

var
  xx_default_string_empty: string = '';
  li: LevelInfo;
  xx_ei: ElementInfo;
  yy_ei: ElementInfo;
  xx_change: ElementChangeInfo;
  xx_group: ElementGroupInfo;
  xx_envelope: EnvelopeInfo;
  xx_default_description: string = '';
  xx_event_bits: array [0..Pred(NUM_CE_BITFIELDS)] of Longword;
  xx_num_contents: integer = 1;
  xx_current_change_page: integer;
  xx_string_length_unused: byte;
  
var chunk_config_INFO: array [0..12] of LevelFileConfigInfo = (
  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+1;
   value:  @li.game_engine_type;	default_value: 	GAME_ENGINE_TYPE_RND
  ),

  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.fieldx;			default_value: 	STD_LEV_FIELDX
  ),
  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.fieldy;			default_value: 	STD_LEV_FIELDY
  ),

  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+3;
   value:  @li.time;			default_value: 	100
  ),

  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+4;
   value:  @li.gems_needed;		default_value: 	0
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+2;
   value:  @li.use_step_counter;	default_value: 	0//False
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$00+4;
   value:  @li.wind_direction_initial;	default_value: 	MV_NONE
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+5;
   value:  @li.em_slippery_gems;	default_value: 	0//False
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+6;
   value:  @li.use_custom_template;	default_value: 	0//False
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+1;
   value:  @li.can_move_into_acid_bits;	default_value: 2147483647
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$00+7;
   value:  @li.dont_collide_with_bits;	default_value: 2147483647
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+5;
   value:  @li.score[SC_TIME_BONUS];	default_value: 	1
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1
  )
);

var chunk_config_ELEM: array [0..89] of LevelFileConfigInfo = (
   
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @li.block_last_field;	default_value:	0//False
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+2;
   value:  @li.sp_block_last_field;	 default_value:	1//True
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+3;
   value:  @li.instant_relocation;	default_value: 0//False
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+4;
   value:  @li.can_pass_to_walkable;	default_value: 0//False
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+5;
   value:  @li.block_snap_field;	default_value: 	1//TRUE
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+6;
   value:  @li.continuous_snapping;	default_value: 1//	TRUE
  ),


  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+7;
   value:  @li.initial_player_stepsize[0];default_value: 	STEPSIZE_NORMAL
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+8;
   value:  @li.initial_player_gravity[0];default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+9;
   value:  @li.use_start_element[0];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @li.start_element[0];	default_value: 	EL_PLAYER_1
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+10;
   value:  @li.use_artwork_element[0];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+2;
   value:  @li.artwork_element[0];	default_value: 	EL_PLAYER_1
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+11;
   value:  @li.use_explosion_element[0];default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_1;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+3;
   value:  @li.explosion_element[0];	default_value: 	EL_PLAYER_1
  ),

  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+7;
   value:  @li.initial_player_stepsize[1];default_value: 	STEPSIZE_NORMAL
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+8;
   value:  @li.initial_player_gravity[1];default_value:  0//	FALSE
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+9;
   value:  @li.use_start_element[1];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @li.start_element[1];	default_value: 	EL_PLAYER_2
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+10;
   value:  @li.use_artwork_element[1];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+2;
   value:  @li.artwork_element[1];	default_value: 	EL_PLAYER_2
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+11;
   value:  @li.use_explosion_element[1];default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_2;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+3;
   value:  @li.explosion_element[1];	default_value: 	EL_PLAYER_2
  ),

  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+7;
   value:  @li.initial_player_stepsize[2];default_value: 	STEPSIZE_NORMAL
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+8;
   value:  @li.initial_player_gravity[2];default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+9;
   value:  @li.use_start_element[2];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @li.start_element[2];	default_value: 	EL_PLAYER_3
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+10;
   value:  @li.use_artwork_element[2];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+2;
   value:  @li.artwork_element[2];	default_value: 	EL_PLAYER_3
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+11;
   value:  @li.use_explosion_element[2];default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_3;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+3;
   value:  @li.explosion_element[2];	default_value: 	EL_PLAYER_3
  ),

  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+7;
   value:  @li.initial_player_stepsize[3];default_value: 	STEPSIZE_NORMAL
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+8;
   value:  @li.initial_player_gravity[3];default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+9;
   value:  @li.use_start_element[3];	default_value: 0//	FALSE
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @li.start_element[3];	default_value: 	EL_PLAYER_4
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+10;
   value:  @li.use_artwork_element[3];	default_value: 	0//  FALSE
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+2;
   value:  @li.artwork_element[3];	default_value: 	EL_PLAYER_4
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+11;
   value:  @li.use_explosion_element[3];default_value: 	0// FALSE
  ),
  (
   element:  EL_PLAYER_4;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+3;
   value:  @li.explosion_element[3];	default_value: 	EL_PLAYER_4
  ),

  (
   element:  EL_EMERALD;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_EMERALD];	default_value: 	10
  ),

  (
   element:  EL_DIAMOND;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_DIAMOND];	default_value: 	10
  ),

  (
   element:  EL_BUG;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_BUG];		default_value: 	10
  ),

  (
   element:  EL_SPACESHIP;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_SPACESHIP];	default_value: 	10
  ),

  (
   element:  EL_PACMAN;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_PACMAN];	default_value: 	10
  ),

  (
   element:  EL_NUT;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_NUT];		default_value: 	10
  ),

  (
   element:  EL_DYNAMITE;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_DYNAMITE];	default_value: 	10
  ),

  (
   element:  EL_KEY_1;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_KEY];		default_value: 	10
  ),

  (
   element:  EL_PEARL;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_PEARL];	default_value: 	10
  ),

  (
   element:  EL_CRYSTAL;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_CRYSTAL];	default_value: 	10
  ),

  (
   element:  EL_BD_AMOEBA;		save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @li.amoeba_content;		default_value: 	EL_DIAMOND
  ),
  (
   element:  EL_BD_AMOEBA;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.amoeba_speed;		default_value: 	10
  ),
  (
   element:  EL_BD_AMOEBA;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @li.grow_into_diggable;	default_value: 	1//TRUE
  ),

  (
   element:  EL_YAMYAM;			save_type: 	-1;
   data_type:  TYPE_CONTENT_LIST;		conf_type: 	$C0+1;
   value:  @li.yamyam_content;		default_value: 	EL_ROCK;value_copy:  nil;
   num_entities:  @li.num_yamyam_contents;	default_num_entities: 	4;max_num_entities:  MAX_ELEMENT_CONTENTS
  ),
  (
   element:  EL_YAMYAM;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_YAMYAM];	default_value: 	10
  ),

  (
   element:  EL_ROBOT;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_ROBOT];	default_value: 	10
  ),
  (
   element:  EL_ROBOT;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.slurp_score;		default_value: 	10
  ),

  (
   element:  EL_ROBOT_WHEEL;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.time_wheel;		default_value: 	10
  ),

  (
   element:  EL_MAGIC_WALL;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.time_magic_wall;	default_value: 	10
  ),

  (
   element:  EL_GAME_OF_LIFE;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+1;
   value:  @li.game_of_life[0];	default_value: 	2
  ),
  (
   element:  EL_GAME_OF_LIFE;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+2;
   value:  @li.game_of_life[1];	default_value: 	3
  ),
  (
   element:  EL_GAME_OF_LIFE;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+3;
   value:  @li.game_of_life[2];	default_value: 	3
  ),
  (
   element:  EL_GAME_OF_LIFE;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+4;
   value:  @li.game_of_life[3];	default_value: 	3
  ),

  (
   element:  EL_BIOMAZE;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+1;
   value:  @li.biomaze[0];		default_value: 	2
  ),
  (
   element:  EL_BIOMAZE;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+2;
   value:  @li.biomaze[1];		default_value: 	3
  ),
  (
   element:  EL_BIOMAZE;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+3;
   value:  @li.biomaze[2];		default_value: 	3
  ),
  (
   element:  EL_BIOMAZE;			save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+4;
   value:  @li.biomaze[3];		default_value: 	3
  ),

  (
   element:  EL_TIMEGATE_SWITCH;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.time_timegate;		default_value: 	10
  ),

  (
   element:  EL_LIGHT_SWITCH_ACTIVE;	save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.time_light;		default_value: 	10
  ),

  (
   element:  EL_SHIELD_NORMAL;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.shield_normal_time;	default_value: 	10
  ),
  (
   element:  EL_SHIELD_NORMAL;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.score[SC_SHIELD];	default_value: 	10
  ),

  (
   element:  EL_SHIELD_DEADLY;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.shield_deadly_time;	default_value: 	10
  ),
  (
   element:  EL_SHIELD_DEADLY;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.score[SC_SHIELD];	default_value: 	10
  ),

  (
   element:  EL_EXTRA_TIME;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.extra_time;		default_value: 	10
  ),
  (
   element:  EL_EXTRA_TIME;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.extra_time_score;	default_value: 	10
  ),

  (
   element:  EL_TIME_ORB_FULL;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.time_orb_time;		default_value: 	10
  ),
  (
   element:  EL_TIME_ORB_FULL;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @li.use_time_orb_bug;	default_value: 	0// FALSE
  ),

  (
   element:  EL_SPRING;			save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @li.use_spring_bug;		default_value: 	0// FALSE
  ),

  (
   element:  EL_EMC_ANDROID;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.android_move_time;	default_value: 	10
  ),
  (
   element:  EL_EMC_ANDROID;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.android_clone_time;	default_value: 	10
  ),
  (
   element:  EL_EMC_ANDROID;		save_type: 	-1;
   data_type:  TYPE_ELEMENT_LIST;		conf_type: 	$C0+1;
   value:  @li.android_clone_element[0];default_value: 	EL_EMPTY;value_copy:  nil;
   num_entities:  @li.num_android_clone_elements;default_num_entities: 	1;max_num_entities:  MAX_ANDROID_ELEMENTS
  ),

  (
   element:  EL_EMC_LENSES;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.lenses_score;		default_value: 	10
  ),
  (
   element:  EL_EMC_LENSES;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.lenses_time;		default_value: 	10
  ),

  (
   element:  EL_EMC_MAGNIFIER;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.magnify_score;		default_value: 	10
  ),
  (
   element:  EL_EMC_MAGNIFIER;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.magnify_time;		default_value: 	10
  ),

  (
   element:  EL_EMC_MAGIC_BALL;		save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.ball_time;		default_value: 	10
  ),
  (
   element:  EL_EMC_MAGIC_BALL;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @li.ball_random;		default_value: 	0// FALSE
  ),
  (
   element:  EL_EMC_MAGIC_BALL;		save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+2;
   value:  @li.ball_state_initial;	default_value: 	0// FALSE
  ),
  (
   element:  EL_EMC_MAGIC_BALL;		save_type: 	-1;
   data_type:  TYPE_CONTENT_LIST;		conf_type: 	$C0+1;
   value:  @li.ball_content;		default_value: 	EL_EMPTY;value_copy:  nil;
   num_entities:  @li.num_ball_contents;	default_num_entities: 	4;max_num_entities:  MAX_ELEMENT_CONTENTS
  ),
  (
   element:  EL_UNKNOWN;			save_type: 	SAVE_CONF_NEVER;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+1;
   value:  @li.score[SC_UNKNOWN_14];	default_value: 	10
  ),
  (
   element:  EL_UNKNOWN;			save_type: 	SAVE_CONF_NEVER;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @li.score[SC_UNKNOWN_15];	default_value: 	10
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1
  )
);

var chunk_config_NOTE: array [0..3] of LevelFileConfigInfo = (
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+1;
   value:  @xx_envelope.xsize;		default_value: 	MAX_ENVELOPE_XSIZE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+2;
   value:  @xx_envelope.ysize;		default_value: 	MAX_ENVELOPE_YSIZE
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_STRING;		conf_type: 	$C0+1;
   value:  @xx_envelope.text;		default_value: 	-1;value_copy:  nil;
   num_entities:  @xx_string_length_unused;	default_num_entities: 	-1;max_num_entities:  MAX_ENVELOPE_TEXT_LEN;
   default_string:  @xx_default_string_empty
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1
  )
);

var chunk_config_CUSX_base: array [0..28] of LevelFileConfigInfo = (
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_STRING;		conf_type: 	$C0+1;
   value:  @xx_ei.description;	default_value: 	-1;
   value_copy:  @yy_ei.description;
   num_entities:  @xx_string_length_unused;	default_num_entities: 	-1;max_num_entities:  MAX_ELEMENT_NAME_LEN;
   default_string:  @xx_default_description
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+1;
   value:  @xx_ei.properties[EP_BITFIELD_BASE_NR];default_value:  EP_BITMASK_BASE_DEFAULT;
   value_copy:  @yy_ei.properties[EP_BITFIELD_BASE_NR]
  ),
{$if 0}
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+2;
    @xx_ei.properties[EP_BITFIELD_BASE_NR +value:  1];default_value:  EP_BITMASK_DEFAULT;
    @yy_ei.properties[EP_BITFIELD_BASE_NR +value_copy:  1]
  ),
{$ifend}

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @xx_ei.use_gfx_element;	default_value: 	0;// FALSE;
   value_copy:  @yy_ei.use_gfx_element
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @xx_ei.gfx_element;		default_value: 	EL_EMPTY_SPACE;
   value_copy:  @yy_ei.gfx_element
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$00+2;
   value:  @xx_ei.access_direction;	default_value: 	MV_ALL_DIRECTIONS;
   value_copy:  @yy_ei.access_direction
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @xx_ei.collect_score_initial;default_value: 	10;
   value_copy:  @yy_ei.collect_score_initial
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+3;
   value:  @xx_ei.collect_count_initial;default_value: 	1;
   value_copy:  @yy_ei.collect_count_initial
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+4;
   value:  @xx_ei.ce_value_fixed_initial;default_value: 	0;
   value_copy:  @yy_ei.ce_value_fixed_initial
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+5;
   value:  @xx_ei.ce_value_random_initial;default_value: 	0;
   value_copy:  @yy_ei.ce_value_random_initial
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+3;
   value:  @xx_ei.use_last_ce_value;	default_value: 	0;// FALSE;
   value_copy:  @yy_ei.use_last_ce_value
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+6;
   value:  @xx_ei.push_delay_fixed;	default_value: 	8;
   value_copy:  @yy_ei.push_delay_fixed
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+7;
   value:  @xx_ei.push_delay_random;	default_value: 	8;
   value_copy:  @yy_ei.push_delay_random
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+8;
   value:  @xx_ei.drop_delay_fixed;	default_value: 	0;
   value_copy:  @yy_ei.drop_delay_fixed
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+9;
   value:  @xx_ei.drop_delay_random;	default_value: 	0;
   value_copy:  @yy_ei.drop_delay_random
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+10;
   value:  @xx_ei.move_delay_fixed;	default_value: 	0;
   value_copy:  @yy_ei.move_delay_fixed
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+11;
   value:  @xx_ei.move_delay_random;	default_value: 	0;
   value_copy:  @yy_ei.move_delay_random
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+3;
   value:  @xx_ei.move_pattern;	default_value: 	MV_ALL_DIRECTIONS;
   value_copy:  @yy_ei.move_pattern
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$00+4;
   value:  @xx_ei.move_direction_initial;default_value: 	MV_START_AUTOMATIC;
   value_copy:  @yy_ei.move_direction_initial
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+5;
   value:  @xx_ei.move_stepsize;		default_value: TILEX div 8;
   value_copy:  @yy_ei.move_stepsize
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+12;
   value:  @xx_ei.move_enter_element;	default_value: 	EL_EMPTY_SPACE;
   value_copy:  @yy_ei.move_enter_element
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+13;
   value:  @xx_ei.move_leave_element;	default_value: 	EL_EMPTY_SPACE;
   value_copy:  @yy_ei.move_leave_element
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+6;
   value:  @xx_ei.move_leave_type;	default_value: 	LEAVE_TYPE_UNLIMITED;
   value_copy:  @yy_ei.move_leave_type
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+7;
   value:  @xx_ei.slippery_type;	default_value: 	SLIPPERY_ANY_RANDOM;
   value_copy:  @yy_ei.slippery_type
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+8;
   value:  @xx_ei.explosion_type;	default_value: 	EXPLODES_3X3;
   value_copy:  @yy_ei.explosion_type
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+14;
   value:  @xx_ei.explosion_delay;	default_value: 	16;
   value_copy:  @yy_ei.explosion_delay
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+15;
   value:  @xx_ei.ignition_delay;	default_value: 	8;
   value_copy:  @yy_ei.ignition_delay
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_CONTENT_LIST;		conf_type: 	$C0+2;
   value:  @xx_ei.content;		default_value: 	EL_EMPTY_SPACE;
   value_copy:  @yy_ei.content;
   num_entities:  @xx_num_contents;		default_num_entities: 	1;max_num_entities:  1
  ),



  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+9;
   value:  @xx_ei.num_change_pages;	default_value: 	1;
   value_copy:  @yy_ei.num_change_pages
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1;
   value_copy:  nil
  )
);

var chunk_config_CUSX_change: array [0..23] of LevelFileConfigInfo = (
   

  (
   element:  -1;				save_type: 	SAVE_CONF_ALWAYS;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+1;
   value:  @xx_current_change_page;	default_value: 	-1
  ),

   

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+2;
   value:  @xx_change.can_change;	default_value: 	0// FALSE
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+1;
   value:  @xx_event_bits[0];		default_value: 	0
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+2;
   value:  @xx_event_bits[1];		default_value: 	0
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$00+3;
   value:  @xx_change.trigger_player;	default_value: 	CH_PLAYER_ANY
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$00+4;
   value:  @xx_change.trigger_side;	default_value: 	CH_SIDE_ANY
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BITFIELD;		conf_type: 	$80+3;
   value:  @xx_change.trigger_page;	default_value: 	CH_PAGE_ANY
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @xx_change.target_element;	default_value: 	EL_EMPTY_SPACE
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+2;
   value:  @xx_change.delay_fixed;	default_value: 	0
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+3;
   value:  @xx_change.delay_random;	default_value: 	0
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+4;
   value:  @xx_change.delay_frames;	default_value: 	FRAMES_PER_SECOND
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+5;
   value:  @xx_change.trigger_element;	default_value: 	EL_EMPTY_SPACE
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+6;
   value:  @xx_change.explode;		default_value: 	0// FALSE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+7;
   value:  @xx_change.use_target_content;default_value: 	0// FALSE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+8;
   value:  @xx_change.only_if_complete;default_value: 	0// FALSE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+9;
   value:  @xx_change.use_random_replace;default_value: 	0// FALSE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+10;
   value:  @xx_change.random_percentage;default_value: 	100
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+11;
   value:  @xx_change.replace_when;	default_value: 	CP_WHEN_EMPTY
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+12;
   value:  @xx_change.has_action;	default_value: 	0// FALSE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+13;
   value:  @xx_change.action_type;	default_value: 	CA_NO_ACTION
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+14;
   value:  @xx_change.action_mode;	default_value: 	CA_MODE_UNDEFINED
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$40+6;
   value:  @xx_change.action_arg;	default_value: 	CA_ARG_UNDEFINED
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_CONTENT_LIST;		conf_type: 	$C0+1;
   value:  @xx_change.target_content;	default_value: 	EL_EMPTY_SPACE;value_copy:  nil;
   num_entities:  @xx_num_contents;		default_num_entities: 	1;max_num_entities:  1
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1
  )
);

var chunk_config_GRPX: array [0..5] of LevelFileConfigInfo = (
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_STRING;		conf_type: 	$C0+1;
   value:  @xx_ei.description;	default_value: 	-1;value_copy:  nil;
   num_entities:  @xx_string_length_unused;	default_num_entities: 	-1;max_num_entities:  MAX_ELEMENT_NAME_LEN;
   default_string:  @xx_default_description
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_BOOLEAN;		conf_type: 	$00+1;
   value:  @xx_ei.use_gfx_element;	default_value: 	0// FALSE
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT;		conf_type: 	$40+1;
   value:  @xx_ei.gfx_element;		default_value: 	EL_EMPTY_SPACE
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_INTEGER;		conf_type: 	$00+2;
   value:  @xx_group.choice_mode;	default_value: 	ANIM_RANDOM
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  TYPE_ELEMENT_LIST;		conf_type: 	$C0+2;
   value:  @xx_group.element[0];	default_value: 	EL_EMPTY_SPACE;value_copy:  nil;
   num_entities:  @xx_group.num_elements;	default_num_entities: 	1;max_num_entities:  MAX_ELEMENTS_IN_GROUP
  ),

  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1
  )
);

var chunk_config_CONF: array [0..9] of LevelFileConfigInfo = (
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_BOOLEAN;			conf_type: $00+9;
    value: @li.block_snap_field;		default_value: 1//TRUE
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_BOOLEAN;			conf_type: $00+13;
    value: @li.continuous_snapping;		default_value: 1//TRUE
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_INTEGER;			conf_type: $00+1;
    value: @li.initial_player_stepsize[0];	default_value: STEPSIZE_NORMAL
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_BOOLEAN;			conf_type: $00+10;
    value: @li.use_start_element[0];		default_value: 0//FALSE
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_ELEMENT;			conf_type: $40+1;
    value: @li.start_element[0];		default_value: EL_PLAYER_1
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_BOOLEAN;			conf_type: $00+11;
    value: @li.use_artwork_element[0];		default_value: 0//FALSE
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_ELEMENT;			conf_type: $40+2;
    value: @li.artwork_element[0];		default_value: EL_PLAYER_1
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_BOOLEAN;			conf_type: $00+12;
    value: @li.use_explosion_element[0];	default_value: 0//FALSE
  ),
  (
    element: EL_PLAYER_1;			save_type: -1;
    data_type: TYPE_ELEMENT;			conf_type: $40+3;
    value: @li.explosion_element[0];		default_value: EL_PLAYER_1
  ),
  (
   element:  -1;				save_type: 	-1;
   data_type:  -1;				conf_type: 	-1;
   value:  nil;			default_value: 	-1
  )
);

implementation

end.
