{*********************************}
{ Generated by c2pas32  v0.9b     }
{ (c) 2001 Oleg Bulychov          }
{ Gladiators Software             }
{ http://www.astonshell.com/      }
{*********************************}

unit files_c;

{$MODE Delphi}

interface

uses Files, rndtypes, main_h, misc_fromsource, Math, SysUtils, conf_chr_h, Dcu1, RNDCE1, Dialogs, init_c;

const
CHUNK_ID_LEN = 4; (* IFF style chunk id length  *)
CHUNK_SIZE_UNDEFINED = 0; (* undefined chunk size == 0  *)
CHUNK_SIZE_NONE = -1; (* do not write chunk size    *)
LEVEL_CHUNK_NAME_SIZE = MAX_LEVEL_NAME_LEN; 
LEVEL_CHUNK_AUTH_SIZE = MAX_LEVEL_AUTHOR_LEN; 
LEVEL_CHUNK_VERS_SIZE = 8; (* size of file version chunk *)
LEVEL_CHUNK_DATE_SIZE = 4; (* size of file date chunk    *)
LEVEL_CHUNK_HEAD_SIZE = 80; (* size of level file header  *)
LEVEL_CHUNK_HEAD_UNUSED = 0; (* unused level header bytes  *)
LEVEL_CHUNK_CNT2_SIZE = 160; (* size of level CNT2 chunk   *)
LEVEL_CHUNK_CNT2_UNUSED = 11; (* unused CNT2 chunk bytes    *)
LEVEL_CHUNK_CNT3_HEADER = 16; (* size of level CNT3 header  *)
LEVEL_CHUNK_CNT3_UNUSED = 10; (* unused CNT3 chunk bytes    *)
LEVEL_CPART_CUS3_SIZE = 134; (* size of CUS3 chunk part    *)
LEVEL_CPART_CUS3_UNUSED = 15; (* unused CUS3 bytes / part   *)
LEVEL_CHUNK_GRP1_SIZE = 74; (* size of level GRP1 chunk   *)
(* (element number, number of change pages, change page number) *)
LEVEL_CHUNK_CUSX_UNCHANGED = (2+(1+1)+(1+1)); 
(* (element number only) *)
LEVEL_CHUNK_GRPX_UNCHANGED = 2; 
LEVEL_CHUNK_NOTE_UNCHANGED = 2; 
(* (nothing at all if unchanged) *)
LEVEL_CHUNK_ELEM_UNCHANGED = 0; 
TAPE_CHUNK_VERS_SIZE = 8; (* size of file version chunk *)
TAPE_CHUNK_HEAD_SIZE = 20; (* size of tape file header   *)
TAPE_CHUNK_HEAD_UNUSED = 3; (* unused tape header bytes   *)

function LEVEL_CHUNK_CNT3_SIZE(x: integer): integer; {<= !!!6 unknown macro}

function LEVEL_CHUNK_CUS3_SIZE(x: integer): integer; {<= !!!6 unknown macro}

function LEVEL_CHUNK_CUS4_SIZE(x: integer): integer; {<= !!!6 unknown macro}
(* file identifier strings *)
const
LEVEL_COOKIE_TMPL = 'ROCKSNDIAMONDS_LEVEL_FILE_VERSION_x.x';
TAPE_COOKIE_TMPL = 'ROCKSNDIAMONDS_TAPE_FILE_VERSION_x.x';
SCORE_COOKIE = 'ROCKSNDIAMONDS_SCORE_FILE_VERSION_1.2';
(* values for deciding when (not) to save configuration data *)
SAVE_CONF_NEVER = 0;
SAVE_CONF_ALWAYS = 1;
SAVE_CONF_WHEN_CHANGED = -1;
(* values for chunks using micro chunks *)
CONF_MASK_1_BYTE = $00;
CONF_MASK_2_BYTE = $40;
CONF_MASK_4_BYTE = $80;
CONF_MASK_MULTI_BYTES = $c0;
CONF_MASK_BYTES = $c0;
CONF_MASK_TOKEN = $3f;

const
CONF_CONTENT_NUM_ELEMENTS = (3*3);
CONF_CONTENT_NUM_BYTES = (CONF_CONTENT_NUM_ELEMENTS*2);
CONF_ELEMENT_NUM_BYTES = (2);

(* temporary variables used to store pointers to structure members *)
var {was static}
  filea: TByteFile;

(* ========================================================================= *)
(* level file functions                                                      *)
(* ========================================================================= *)

function LoadLevelFromFileInfo_RND(level: pLevelInfo; var elements: ElemInfoArr; filename: string): boolean;
procedure setLevelInfoToDefaults(level: pLevelInfo; var elements: ElemInfoArr);
procedure setElementChangePages(ei: pElementInfo;  change_pages: integer);
procedure SaveLevelFromFilename(level: pLevelInfo;  filename: pchar);
procedure SetElementInfoToDefaults(var elements: ElemInfoArr; element: integer);
function getMappedElement(element: integer): integer;
function getMappedElementByVersion(element: integer;  game_version: integer): integer;
procedure resetEventBits();
procedure setEventFlagsFromEventBits(change: pElementChangeInfo);

var
  chunknames: String;

implementation

uses chunk_confs;

procedure resetEventFlags(change: pElementChangeInfo);
var
  i: integer;
begin
  for i:=0 to Pred(NUM_CHANGE_EVENTS) do
   change.has_event[i]:= LongBool(0);
end;

procedure resetEventBits();
var
  i: integer;
begin
  for i:=0 to Pred(NUM_CE_BITFIELDS) do
   xx_event_bits[i]:= 0;
end;

procedure setEventFlagsFromEventBits(change: pElementChangeInfo);
var
i: integer; (* important: only change event flag if corresponding event bit is set *)
begin
  for i:=0 to Pred(NUM_CHANGE_EVENTS) do
  if (xx_event_bits[CH_EVENT_BITFIELD_NR(i)] and CH_EVENT_BIT(i)) <>0 then
   change.has_event[i]:= LongBool(1);
end;

procedure setEventBitsFromEventFlags(change: pElementChangeInfo);
var
i: integer; (* important: only change event bit if corresponding event flag is set *)
begin
  for i:=0 to Pred(NUM_CHANGE_EVENTS) do
  if change.has_event[i] then
   xx_event_bits[CH_EVENT_BITFIELD_NR(i)]:=
    xx_event_bits[CH_EVENT_BITFIELD_NR(i)] or (CH_EVENT_BIT(i));
end;
var {was static}
description: string;

function getDefaultElementDescription(ei: pElementInfo): string;
var
  default_description: string;
begin
  if ei.custom_description<>'' then
   default_description:=ei.custom_description
  else default_description:=ei.editor_description;
  description:=copy(default_description,1, MAX_ELEMENT_NAME_LEN);
  (* truncate element description to MAX_ELEMENT_NAME_LEN bytes *)
  begin
    result:=description;
    exit;
  end;
end;

procedure setElementDescriptionToDefault(ei: pElementInfo);
var
  default_description: string;
begin
  default_description:=getDefaultElementDescription(ei);
  ei.description:=Copy(default_description, 1, MAX_ELEMENT_NAME_LEN);
end;

procedure setConfigToDefaultsFromConfigList(conf: array of LevelFileConfigInfo);
var
  confposi, default_value, data_type, conf_type: integer;
  byte_mask, default_num_entities, max_num_entities: integer;
  default_string: String;
  element_array: PIntArr;
  content: PContentArr;
  j, c, x, y, stopat: integer;
begin
  confposi:=0;
  stopat:=high(conf);
  while (confposi < stopat) {and (conf[confposi].data_type<>-1)} do
  begin
    default_value:=conf[confposi].default_value;
    data_type:=conf[confposi].data_type;
    conf_type:=conf[confposi].conf_type;
    byte_mask:=conf_type and CONF_MASK_BYTES;
    if byte_mask=CONF_MASK_MULTI_BYTES then
    begin
      default_num_entities:=conf[confposi].default_num_entities;
      max_num_entities:=conf[confposi].max_num_entities;
      pinteger(conf[confposi].num_entities)^:=default_num_entities;

      if data_type=TYPE_STRING then
      begin
        default_string:=conf[confposi].default_string^;
        PChar(conf[confposi].value):=PChar(default_string);
      end
      else
      if data_type=TYPE_ELEMENT_LIST then
      begin
        element_array:=pintarr(conf[confposi].value);
        for j:=0 to Pred(max_num_entities) do
          element_array^[j]:= default_value;
      end
      else
      if data_type=TYPE_CONTENT_LIST then
      begin
        content:=conf[confposi].value;
        for c:=0 to Pred(max_num_entities) do
        for y:=0 to Pred(3) do
        for x:=0 to Pred(3) do
          content^[c].e[x, y]:= default_value;
      end;
    end
    else
    begin
      (* constant size configuration data (1, 2 or 4 bytes) *)
      if data_type=TYPE_BOOLEAN then
       pboolean(conf[confposi].value)^:=longbool(default_value)
      else pinteger(conf[confposi].value)^:=default_value;
    end;
    inc(confposi);
    if confposi >= stopat then Break;
  end;
end;

procedure setElementChangePages(ei: pElementInfo;  change_pages: integer);
begin
  ei.num_change_pages:= MAX(1,change_pages);
//***ZZZ*** not needed because of static size  SetLength(ei.change_page, ei.num_change_pages);
  if ei.current_change_page>=ei.num_change_pages then ei.current_change_page:= ei.num_change_pages-1;
  ei.change:=@ei.change_page[ei.current_change_page];
end;

procedure setElementChangeInfoToDefaults(change: pElementChangeInfo);
begin
  xx_change := change^;		//* copy change data into temporary buffer */
//  xx_num_contents := 1;// not needed, set by setConfigToDefaultsFromConfiglist
  setConfigToDefaultsFromConfigList(chunk_config_CUSX_change);
  change^ := xx_change;
  resetEventFlags(change);
end;

procedure SetElementInfoToDefaults(var elements: ElemInfoArr; element: integer);
var
  ei: pElementInfo;
  envelope_nr: integer;
  group: pElementGroupInfo;
begin
  ei:=@elements[element];
  if IS_ENVELOPE(element) then
  begin
// only works for default level, not on external ones
// - which doesn't matter since the others cannot be saved
    envelope_nr:=element-EL_ENVELOPE_1;
    setConfigToDefaultsFromConfigList(chunk_config_NOTE);
    lvl.envelope[envelope_nr]:= xx_envelope;
  end;

  if IS_CUSTOM_ELEMENT(element) or IS_GROUP_ELEMENT(element) or
   IS_INTERNAL_ELEMENT(element) then
  begin
    xx_ei:=ei^;// is this needed? xx_ei is set to what it should be...
    setConfigToDefaultsFromConfigList(chunk_config_CUSX_base);
    (* copy element data into temporary buffer *)
    ei^:=xx_ei;
  end;

  setElementChangePages(ei,1);
  setElementChangeInfoToDefaults(ei.change);
  if IS_CUSTOM_ELEMENT(element) or IS_GROUP_ELEMENT(element) then
  begin
// ***ZZZ*** use this to set up correct CE & GE descriptions
    ei.custom_description:='';// ***ZZZ*** make sure that no custom_description overrides default_description
    if IS_CUSTOM_ELEMENT(element) then ei.editor_description:='custom element ' + inttostr(element-EL_CUSTOM_START+1)
    else if IS_GROUP_ELEMENT(element) then ei.editor_description:='group element ' + inttostr(element-EL_GROUP_START+1);

    setElementDescriptionToDefault(ei);
    ei.modified_settings:= LongBool(0);
  end;
  if IS_CUSTOM_ELEMENT(element) or IS_INTERNAL_ELEMENT(element) then
  begin
    ei.access_type:= 0;
    ei.access_layer:= 0;
    ei.access_protected:= 0;
    ei.walk_to_action:= 0;
    ei.smash_targets:= 0;
    ei.deadliness:= 0;
    ei.can_explode_by_fire:= LongBool(0);
    ei.can_explode_smashed:= LongBool(0);
    ei.can_explode_impact:= LongBool(0);
    ei.current_change_page:= 0; (* internal values used in level editor *)
    (* !!! now done in InitElementPropertiesStatic() (see above) !!! *)
    (* !!! (else properties set there will be overwritten here)  !!! *)
    (* start with no properties at all *)
  end;
  if IS_GROUP_ELEMENT(element) or IS_INTERNAL_ELEMENT(element) then
  begin
// if ei.group = nil then New(ei.group);// no pointers can be used in scripts
    group:= @ei.group;

    xx_group:=group^;
    setConfigToDefaultsFromConfigList(chunk_config_GRPX);
    (* copy group data into temporary buffer *)
    group^:=xx_group;
  end;
end;

procedure setLevelInfoToDefaults(level: pLevelInfo; var elements: ElemInfoArr);
var
i: integer;
x: integer;
y: integer;
//  BorderElement: Integer;
begin
  InitElementPropertiesStatic;
  li:=level^;
  setConfigToDefaultsFromConfigList(chunk_config_INFO);
  (* copy level data into temporary buffer *)
  setConfigToDefaultsFromConfigList(chunk_config_ELEM);

  level^:=li; (* copy temporary buffer back to level data *)
//  setLevelInfoToDefaults_EM();
//  level.native_em_level:= @native_em_level;
  level.file_version:= FILE_VERSION_ACTUAL;
  level.game_version:= GAME_VERSION_ACTUAL;
  level.creation_date.day:=StrToInt(FormatDateTime('d',Date));
  level.creation_date.month:=StrToInt(FormatDateTime('m',Date));
  level.creation_date.year:=StrToInt(FormatDateTime('yyyy',Date));
  level.encoding_16bit_field:= LongBool(1);
  level.encoding_16bit_yamyam:= LongBool(1);
  level.encoding_16bit_amoeba:= LongBool(1);
  for x:=0 to Pred(MAX_LEV_FIELDX) do
  for y:=0 to Pred(MAX_LEV_FIELDY) do
   level.field[x][y]:= EL_SAND;

  level.name:=NAMELESS_LEVEL_NAME;
  level.author:=ANONYMOUS_NAME;
  level.field[0][0]:= EL_PLAYER_1;
  level.field[STD_LEV_FIELDX-1][STD_LEV_FIELDY-1]:= EL_EXIT_CLOSED;
  for i:=Min(EL_ENVELOPE_1, EL_CUSTOM_START) to Pred(NUM_FILE_ELEMENTS) do
    SetElementInfoToDefaults(elements, i);

//  BorderElement:= EL_STEELWALL;// ***ZZZ*** value assigned never used
  level.no_valid_file:= LongBool(0);
  level.changed:= LongBool(0);

//***ZZZ*** leveldir_current code stuff checks deleted, I've got other ways of reading that info
// but I don't think that will be needed anyways.
end;

procedure setFileInfoToDefaults(level_file_info: pLevelFileInfo);
begin
  level_file_info.nr:= 0;
  level_file_info.typea:= LEVEL_FILE_TYPE_UNKNOWN;
  level_file_info.packeda:= LongBool(0);
  level_file_info.basename:= nil;
  level_file_info.filename:= nil;
end;

var {was static}
filename: pchar;


function getLevelFilenameFromBasename(basename: pchar): pchar;
begin
  filename:=Pchar(ExtractFileName(String(Basename)));
  Result:=filename;
end;

(* ------------------------------------------------------------------------- *)
(* functions for loading R'n'D level                                         *)
(* ------------------------------------------------------------------------- *)

function getMappedElement(element: integer): integer; 
begin(* remap some (historic, now obsolete) elements *)
  case element of
    EL_PLAYER_OBSOLETE:
    begin
      element:= EL_PLAYER_1; 
    end;
    EL_KEY_OBSOLETE:
    begin
      element:= EL_KEY_1;
      {goto next_label;}{<= !!!d case label without "break"}
    end;
    EL_EM_KEY_1_FILE_OBSOLETE:
    begin
      element:= EL_EM_KEY_1;
    end;
    EL_EM_KEY_2_FILE_OBSOLETE:
    begin
      element:= EL_EM_KEY_2;
    end;
    EL_EM_KEY_3_FILE_OBSOLETE:
    begin
      element:= EL_EM_KEY_3;
    end;
    EL_EM_KEY_4_FILE_OBSOLETE:
    begin
      element:= EL_EM_KEY_4;
    end;
    EL_ENVELOPE_OBSOLETE:
    begin
      element:= EL_ENVELOPE_1;
    end;
    EL_SP_EMPTY:
    begin
      element:= EL_EMPTY;
    end;
    else
    begin
      if element>=NUM_FILE_ELEMENTS then
      begin
        Debug('WARNING: invalid level element '+IntToStr(element) + ', at pos ' + IntToStr(FilePos(Filea)));
        element:= EL_UNKNOWN;
      end;
    end;
  end;{case?}
  begin
    result:= element;
    exit;
  end;
end;

function getMappedElementByVersion(element: integer;  game_version: integer): integer; 
begin(* remap some elements due to certain game version *)
  if game_version<=VERSION_IDENT(2,2,0,0)
  then
  begin 
    (* map game font elements *)
    if element = EL_CHAR('[') then element:=EL_CHAR_AUMLAUT
    else if element = EL_CHAR(#92) then element:=EL_CHAR_OUMLAUT
    else if element=EL_CHAR(']') then element:=EL_CHAR_UUMLAUT
    else if element=EL_CHAR('^') then element:=EL_CHAR_COPYRIGHT
    else element:=element;
  end;
  if game_version<VERSION_IDENT(3,0,0,0)
  then
  begin 
    (* map Supaplex gravity tube elements *)
    if element=EL_SP_GRAVITY_PORT_LEFT then element:=EL_SP_PORT_LEFT
    else if element=EL_SP_GRAVITY_PORT_RIGHT then element:=EL_SP_PORT_RIGHT
    else if element=EL_SP_GRAVITY_PORT_UP then element:=EL_SP_PORT_UP
    else if element=EL_SP_GRAVITY_PORT_DOWN then element:=EL_SP_PORT_DOWN
    else element:=element;
  end;
  begin
    result:= element;
    exit;
  end;
end;

function LoadLevel_VERS(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
begin
  level.file_version:= Files.getFileVersion(filea);
  level.game_version:= Files.getFileVersion(filea);
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_DATE(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
begin
  level.creation_date.year:= getFile16BitBE(filea);
  level.creation_date.month:= getFile8Bit(filea);
  level.creation_date.day:= getFile8Bit(filea);
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_HEAD(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
initial_player_stepsize: integer;
initial_player_gravity: integer;
i: integer;
x: integer;
y: integer;
begin
  level.fieldx:= getFile8Bit(filea);
  level.fieldy:= getFile8Bit(filea);
  level.time:= getFile16BitBE(filea);
  level.gems_needed:= getFile16BitBE(filea);
  level.name:='';// don't add directly, erase old value first
  for{while} i:=0 to Pred(MAX_LEVEL_NAME_LEN) { i++} do
  begin
    x:=getFile8Bit(filea);
    if i <> Length(level.name) then x:=0;// one x has been skipped, skip the rest
    if x = 0 then continue;
    level.name:= level.name + Chr(x);
  end;
//  level.name[MAX_LEVEL_NAME_LEN]:= #0;
  for i:=0 to Pred(LEVEL_SCORE_ELEMENTS) do
  level.score[i]:= getFile8Bit(filea); 
  level.num_yamyam_contents:= STD_ELEMENT_CONTENTS; 
  for i:=0 to Pred(STD_ELEMENT_CONTENTS) do
  for y:=0 to Pred(3) do
  for x:=0 to Pred(3) do
   level.yamyam_content[i].e[x][y]:= getMappedElement(getFile8Bit(filea));
  level.amoeba_speed:= getFile8Bit(filea); 
  level.time_magic_wall:= getFile8Bit(filea); 
  level.time_wheel:= getFile8Bit(filea); 
  level.amoeba_content:= getMappedElement(getFile8Bit(filea));
  if getFile8Bit(filea)=1 then initial_player_stepsize:=STEPSIZE_FAST
  else initial_player_stepsize:=STEPSIZE_NORMAL;
  for i:=0 to Pred(MAX_PLAYERS) do
  level.initial_player_stepsize[i]:= initial_player_stepsize;
  if getFile8Bit(filea)=1 then initial_player_gravity:=1
  else initial_player_gravity:=0;
  for i:=0 to Pred(MAX_PLAYERS) do
   level.initial_player_gravity[i]:= Longbool(initial_player_gravity);
  level.encoding_16bit_field:= (getFile8Bit(filea)=1);
  level.em_slippery_gems:= (getFile8Bit(filea)=1);
  level.use_custom_template:= (getFile8Bit(filea)=1);
  level.block_last_field:= (getFile8Bit(filea)=1);
  level.sp_block_last_field:= (getFile8Bit(filea)=1);
  level.can_move_into_acid_bits:= getFile32BitBE(filea);
  level.dont_collide_with_bits:= getFile8Bit(filea);
  level.use_spring_bug:= (getFile8Bit(filea)=1);
  level.use_step_counter:= Integer(getFile8Bit(filea)=1);
  level.instant_relocation:= (getFile8Bit(filea)=1);
  level.can_pass_to_walkable:= (getFile8Bit(filea)=1);
  level.grow_into_diggable:= (getFile8Bit(filea)=1);
  level.game_engine_type:= getFile8Bit(filea); 
  ReadUnusedBytesFromFile(filea,LEVEL_CHUNK_HEAD_UNUSED); 
  begin
    result:= chunk_size; 
    exit;
  end;
end;

function LoadLevel_NAME(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
  i, x: integer;
begin
  level.name:='';// don't add directly, erase the old value first
  for{while} i:=0 to Pred(MAX_LEVEL_NAME_LEN) { i++} do
  begin
    x:=getFile8Bit(filea);
    if i <> Length(level.name) then x:=0;// one x has been skipped, skip the rest
    if x = 0 then continue;// stop loading
    level.name:=level.name + Chr(x);
  end;
  begin
    result:= chunk_size; 
    exit;
  end;
end;

function LoadLevel_AUTH(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
  i, x: integer;
begin
  level.author:='';// don't add directly, erase the old value first
  for{while} i:=0 to Pred(MAX_LEVEL_AUTHOR_LEN) { i++} do
  begin
    x:=getFile8Bit(filea);
    if i <> Length(level.author) then x:=0;// one x has been skipped, skip the rest
    if x = 0 then continue;// stop loading
    level.author:=level.author + Chr(x);
  end;
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_BODY(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
x: integer;
y: integer;
chunk_size_expected: integer;
 (* Note: "chunk_size" was wrong before version 2.0 when elements are
     stored with 16-bit encoding (and should be twice as big then).
     Even worse, playfield data was stored 16-bit when only yamyam content
     contained 16-bit elements and vice versa. *)
begin
  chunk_size_expected:=level.fieldx*level.fieldy; (* Note: "chunk_size" was wrong before version 2.0 when elements are
       stored with 16-bit encoding (and should be twice as big then).
       Even worse, playfield data was stored 16-bit when only yamyam content
       contained 16-bit elements and vice versa. *)
  if level.encoding_16bit_field and (level.file_version>=FILE_VERSION_2_0) then
   chunk_size_expected:= chunk_size_expected * (2);
  if chunk_size_expected<>chunk_size then
  begin
    ReadUnusedBytesFromFile(filea,chunk_size);
    result:= chunk_size_expected;
    exit;
  end;
  for y:=0 to Pred(level.fieldy) do
  for x:=0 to Pred(level.fieldx) do
  if level.encoding_16bit_field then level.field[x][y]:=getMappedElement(getFile16BitBE(filea))
  else level.field[x][y]:= getMappedElement(getFile8Bit(filea));

  result:= chunk_size;
end;

function LoadLevel_CONT(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
i: integer; 
x: integer; 
y: integer; 
header_size: integer;
 
content_size: integer;
 
chunk_size_expected: integer;
 (* Note: "chunk_size" was wrong before version 2.0 when elements are
     stored with 16-bit encoding (and should be twice as big then).
     Even worse, playfield data was stored 16-bit when only yamyam content
     contained 16-bit elements and vice versa. *)
begin
  
  
  
  header_size:=4; 
  content_size:=MAX_ELEMENT_CONTENTS*3*3; 
  chunk_size_expected:=header_size+content_size; (* Note: "chunk_size" was wrong before version 2.0 when elements are
       stored with 16-bit encoding (and should be twice as big then).
       Even worse, playfield data was stored 16-bit when only yamyam content
       contained 16-bit elements and vice versa. *)
  if level.encoding_16bit_field and(level.file_version>=FILE_VERSION_2_0)
  then
  chunk_size_expected:= chunk_size_expected + (content_size); 
  if chunk_size_expected<>chunk_size
  then
  begin 
    ReadUnusedBytesFromFile(filea,chunk_size); 
    begin
      result:= chunk_size_expected; 
      exit;
    end;
  end;
  getFile8Bit(filea); 
  level.num_yamyam_contents:= getFile8Bit(filea); 
  getFile8Bit(filea); 
  getFile8Bit(filea); 
  (* correct invalid number of content fields -- should never happen *)
  if (level.num_yamyam_contents<1)or(level.num_yamyam_contents>MAX_ELEMENT_CONTENTS)
  then
  level.num_yamyam_contents:= STD_ELEMENT_CONTENTS; 
  for{while} i:=0 to Pred(MAX_ELEMENT_CONTENTS) { i++}
  do
  for{while} y:=0 to Pred(3) { y++}
  do
  for{while} x:=0 to Pred(3) { x++}
  do
  if level.encoding_16bit_field then
   level.yamyam_content[i].e[x][y]:= getMappedElement(getFile16BitBE(filea))
   else level.yamyam_content[i].e[x][y]:= getFile8Bit(filea);
  begin
    result:= chunk_size; 
    exit;
  end;
end;

function LoadLevel_CNT2(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
i: integer; 
x: integer; 
y: integer; 
element: integer; 
num_contents: integer;
//content_xsize: integer;
//content_ysize: integer;
content_array: array [0..Pred(MAX_ELEMENT_CONTENTS),0..Pred(3),0..Pred(3)] of integer;
begin
  element:= getMappedElement(getFile16BitBE(filea));
  num_contents:= getFile8Bit(filea);
  {content_xsize:= }getFile8Bit(filea);// ***ZZZ*** value assigned never used
  {content_ysize:= }getFile8Bit(filea);
  ReadUnusedBytesFromFile(filea,LEVEL_CHUNK_CNT2_UNUSED);
  for i:=0 to Pred(MAX_ELEMENT_CONTENTS) do
  for y:=0 to Pred(3) do
  for x:=0 to Pred(3) do
  content_array[i][x][y]:= getMappedElement(getFile16BitBE(filea));
   (* correct invalid number of content fields -- should never happen *)
  if (num_contents<1)or(num_contents>MAX_ELEMENT_CONTENTS) then num_contents:= STD_ELEMENT_CONTENTS;

  if element=EL_YAMYAM then
  begin
    level.num_yamyam_contents:= num_contents;
    for i:=0 to Pred(num_contents) do
    for y:=0 to Pred(3) do
    for x:=0 to Pred(3) do
    level.yamyam_content[i].e[x][y]:= content_array[i][x][y];
  end
  else
  if element=EL_BD_AMOEBA then
  begin
    level.amoeba_content:= content_array[0][0][0];
  end
  else
  begin
    Debug('ERROR: cannot load content for element '#39+IntToStr(element)+#39);
  end;
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_CNT3(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
i: integer; 
element: integer; 
envelope_nr: integer; 
envelope_len: integer; 
chunk_size_expected: integer; 
begin
  element:= getMappedElement(getFile16BitBE(filea));
  if not IS_ENVELOPE(element) then element:= EL_ENVELOPE_1;
  element_info[element].modified_settings:=True;
  envelope_nr:= element-EL_ENVELOPE_1;
  envelope_len:= getFile16BitBE(filea); 
  level.envelope[envelope_nr].xsize:= getFile8Bit(filea); 
  level.envelope[envelope_nr].ysize:= getFile8Bit(filea); 
  ReadUnusedBytesFromFile(filea,LEVEL_CHUNK_CNT3_UNUSED); 
  chunk_size_expected:= LEVEL_CHUNK_CNT3_SIZE(envelope_len); 
  if chunk_size_expected<>chunk_size then
  begin 
    ReadUnusedBytesFromFile(filea,chunk_size-LEVEL_CHUNK_CNT3_HEADER); 
    begin
      result:= chunk_size_expected; 
      exit;
    end;
  end;
  SetLength(level.envelope[envelope_nr].text, envelope_len);
  for i:=1 to envelope_len do
   level.envelope[envelope_nr].text[i]:= Chr(getFile8Bit(filea));
  begin
    result:= chunk_size; 
    exit;
  end;
end;

function LoadLevel_CUS1(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
num_changed_custom_elements: integer;
chunk_size_expected: integer;
i: integer;
element: integer;
properties: integer;
begin
  num_changed_custom_elements:=getFile16BitBE(filea);
  chunk_size_expected:=2+num_changed_custom_elements*6;
  if chunk_size_expected<>chunk_size
  then
  begin
    ReadUnusedBytesFromFile(filea,chunk_size-2);
    begin
      result:= chunk_size_expected;
      exit;
    end;
  end;
  for{while} i:=0 to Pred(num_changed_custom_elements) { i++}
  do
  begin
    element:=getMappedElement(getFile16BitBE(filea));
    properties:=getFile32BitBE(filea);
    if IS_CUSTOM_ELEMENT(element) then
     element_info[element].properties[EP_BITFIELD_BASE_NR]:= properties
    else Debug('ERROR: invalid custom element number '+IntToStr(element));
    element_info[element].push_delay_fixed:= -1;
    element_info[element].push_delay_random:= -1; (* needed for older levels (see src/init.c for details) *)
    (* initialize later *)
    (* initialize later *)
  end;
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_CUS2(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
num_changed_custom_elements: integer;
chunk_size_expected: integer;
i: integer;
element: integer;
custom_target_element: integer;
begin
  num_changed_custom_elements:=getFile16BitBE(filea);
  chunk_size_expected:=2+num_changed_custom_elements*4;
  if chunk_size_expected<>chunk_size then
  begin
    ReadUnusedBytesFromFile(filea,chunk_size-2);
    begin
      result:= chunk_size_expected;
      exit;
    end;
  end;
  for{while} i:=0 to Pred(num_changed_custom_elements) { i++}
  do
  begin
    element:=getMappedElement(getFile16BitBE(filea));
    custom_target_element:=getMappedElement(getFile16BitBE(filea));
    if IS_CUSTOM_ELEMENT(element)
    then
    element_info[element].change.target_element:= custom_target_element
    else
    Debug('ERROR: invalid custom element number '+IntToStr(element));
  end;
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_CUS3(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
num_changed_custom_elements: integer;
chunk_size_expected: integer;
i, j, x, y: integer;
element: integer;
event_bits: Cardinal;
ei: pElementInfo;
begin
  num_changed_custom_elements:=getFile16BitBE(filea);
  chunk_size_expected:=LEVEL_CHUNK_CUS3_SIZE(num_changed_custom_elements);
  if chunk_size_expected<>chunk_size then
  begin
    ReadUnusedBytesFromFile(filea,chunk_size-2);
    begin
      result:= chunk_size_expected;
      exit;
    end;
  end;
  for{while} i:=0 to Pred(num_changed_custom_elements) { i++}
  do
  begin
    element:=getMappedElement(getFile16BitBE(filea));
    if not IS_CUSTOM_ELEMENT(element) then
    begin
      Debug('ERROR: invalid custom element number '+IntToStr(element));
      element:= EL_INTERNAL_DUMMY;
    end;
    ei:=@element_info[element];
    for{while} j:=0 to Pred(MAX_ELEMENT_NAME_LEN) { j++} do
     ei.description[j+1]:= Chr(getFile8Bit(filea));
    ei.description[MAX_ELEMENT_NAME_LEN+1]:= #0;

    ei.properties[EP_BITFIELD_BASE_NR]:= getFile32BitBE(filea);

    ReadUnusedBytesFromFile(filea,7);
    (* some free bytes for future properties and padding *)
    ei.use_gfx_element:= Boolean(getFile8Bit(filea));
    ei.gfx_element:= getMappedElement(getFile16BitBE(filea)); 
    ei.collect_score_initial:= getFile8Bit(filea); 
    ei.collect_count_initial:= getFile8Bit(filea); 
    ei.push_delay_fixed:= getFile16BitBE(filea); 
    ei.push_delay_random:= getFile16BitBE(filea); 
    ei.move_delay_fixed:= getFile16BitBE(filea); 
    ei.move_delay_random:= getFile16BitBE(filea); 
    ei.move_pattern:= getFile16BitBE(filea); 
    ei.move_direction_initial:= getFile8Bit(filea); 
    ei.move_stepsize:= getFile8Bit(filea); 
    for{while} y:=0 to Pred(3) { y++}
    do
    for{while} x:=0 to Pred(3) { x++}
    do
    ei.content.e[x][y]:= getMappedElement(getFile16BitBE(filea)); 
    event_bits:= getFile32BitBE(filea); 
    for{while} j:=0 to Pred(NUM_CHANGE_EVENTS) { j++}
    do
    if (event_bits and (1 shl j)) <> 0 then
     ei.change.has_event[j]:= LongBool(1);
    ei.change.target_element:= getMappedElement(getFile16BitBE(filea)); 
    ei.change.delay_fixed:= getFile16BitBE(filea); 
    ei.change.delay_random:= getFile16BitBE(filea); 
    ei.change.delay_frames:= getFile16BitBE(filea); 
    ei.change.trigger_element:= getMappedElement(getFile16BitBE(filea));
    ei.change.explode:= Boolean(getFile8Bit(filea));
    ei.change.use_target_content:= Boolean(getFile8Bit(filea));
    ei.change.only_if_complete:= Boolean(getFile8Bit(filea));
    ei.change.use_random_replace:= Boolean(getFile8Bit(filea));
    ei.change.random_percentage:= getFile8Bit(filea);
    ei.change.replace_when:= getFile8Bit(filea); 
    for{while} y:=0 to Pred(3) { y++}
    do
    for{while} x:=0 to Pred(3) { x++}
    do
    ei.change.target_content.e[x][y]:= getMappedElement(getFile16BitBE(filea)); 
    ei.slippery_type:= getFile8Bit(filea); 
    ReadUnusedBytesFromFile(filea,LEVEL_CPART_CUS3_UNUSED); 
    (* some free bytes for future properties and padding *)
    ei.modified_settings:= LongBool(1);
    (* mark that this custom element has been modified *)
  end;
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_CUS4(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
chunk_size_expected: integer;
element: integer;
i: integer;
j: integer;
x: integer;
y: integer; (* ---------- custom element base property values (96 bytes) ------------- *)
event_bits: Cardinal; (* always start with reliable default values *)
ei: pElementInfo;
change: pElementChangeInfo;
begin
  element:= getMappedElement(getFile16BitBE(filea));
  if not IS_CUSTOM_ELEMENT(element) then
  begin
    Debug('ERROR: invalid custom element number '+IntToStr(element));
    ReadUnusedBytesFromFile(filea,chunk_size-2);
    begin
      result:= chunk_size;
      exit;
    end;
  end;
  ei:=@element_info[element];
  ei.description:='';
  for{while} i:=0 to Pred(MAX_ELEMENT_NAME_LEN) { i++} do
  begin
    x:=getFile8Bit(filea);
    if i <> Length(ei.description) then x:=0;// one x has been skipped, skip the rest
    if x = 0 then continue;
    ei.description:= ei.description + Chr(x);
  end;
//  for{while} i:=0 to Pred(MAX_ELEMENT_NAME_LEN) { i++} do
//  ei.description[MAX_ELEMENT_NAME_LEN+1]:= #0;

  ei.properties[EP_BITFIELD_BASE_NR]:= getFile32BitBE(filea);

  ReadUnusedBytesFromFile(filea,4);
  ei.num_change_pages:= getFile8Bit(filea);
  chunk_size_expected:= LEVEL_CHUNK_CUS4_SIZE(ei.num_change_pages); (* reserved for more base properties *)
  if chunk_size_expected<>chunk_size
  then
  begin
    ReadUnusedBytesFromFile(filea,chunk_size-43);
    begin
      result:= chunk_size_expected;
      exit;
    end;
  end;
  ei.ce_value_fixed_initial:= getFile16BitBE(filea);
  ei.ce_value_random_initial:= getFile16BitBE(filea);
  ei.use_last_ce_value:= Boolean(getFile8Bit(filea));
  ei.use_gfx_element:= Boolean(getFile8Bit(filea));
  ei.gfx_element:= getMappedElement(getFile16BitBE(filea));
  ei.collect_score_initial:= getFile8Bit(filea);
  ei.collect_count_initial:= getFile8Bit(filea);
  ei.drop_delay_fixed:= getFile8Bit(filea);
  ei.push_delay_fixed:= getFile8Bit(filea);
  ei.drop_delay_random:= getFile8Bit(filea);
  ei.push_delay_random:= getFile8Bit(filea);
  ei.move_delay_fixed:= getFile16BitBE(filea);
  ei.move_delay_random:= getFile16BitBE(filea);
  ei.move_pattern:= getFile16BitBE(filea);
  ei.move_direction_initial:= getFile8Bit(filea);
  ei.move_stepsize:= getFile8Bit(filea);
  ei.slippery_type:= getFile8Bit(filea); (* bits 0 - 15 of "move_pattern" ... *)
  for{while} y:=0 to Pred(3) { y++}
  do
  for{while} x:=0 to Pred(3) { x++}
  do
  ei.content.e[x][y]:= getMappedElement(getFile16BitBE(filea));
  ei.move_enter_element:= getMappedElement(getFile16BitBE(filea));
  ei.move_leave_element:= getMappedElement(getFile16BitBE(filea));
  ei.move_leave_type:= getFile8Bit(filea);
  ei.move_pattern:= ei.move_pattern or ((getFile16BitBE(filea) shl 16));
  ei.access_direction:= getFile8Bit(filea);
  ei.explosion_delay:= getFile8Bit(filea);
  ei.ignition_delay:= getFile8Bit(filea);
  ei.explosion_type:= getFile8Bit(filea);
  ReadUnusedBytesFromFile(filea,1);
  (* ... bits 16 - 31 of "move_pattern" (not nice, but downward compatible) *)
  (* some free bytes for future custom property values and padding *)
  setElementChangePages(ei,ei.num_change_pages);
  (* ---------- change page property values (48 bytes) --------------------- *)
  for{while} i:=0 to Pred(ei.num_change_pages) { i++}
  do
  begin
    change:=@ei.change_page[i];
    setElementChangeInfoToDefaults(change);
    event_bits:= getFile32BitBE(filea); (* bits 0 - 31 of "has_event[]" ... *)
    j:=0;
    while j<MIN(NUM_CHANGE_EVENTS,32) do
    begin
      if (event_bits and (1 shl j)) <> 0 then
       change.has_event[j]:= LongBool(1);
      inc(j);
    end;
    change.target_element:= getMappedElement(getFile16BitBE(filea));
    change.delay_fixed:= getFile16BitBE(filea);
    change.delay_random:= getFile16BitBE(filea);
    change.delay_frames:= getFile16BitBE(filea);
    change.trigger_element:= getMappedElement(getFile16BitBE(filea));
    change.explode:= Boolean(getFile8Bit(filea));
    change.use_target_content:= Boolean(getFile8Bit(filea));
    change.only_if_complete:= Boolean(getFile8Bit(filea));
    change.use_random_replace:= Boolean(getFile8Bit(filea));
    change.random_percentage:= getFile8Bit(filea);
    change.replace_when:= getFile8Bit(filea);
    for y:=0 to Pred(3) do
    for x:=0 to Pred(3) do
     change.target_content.e[x][y]:= getMappedElement(getFile16BitBE(filea));
    change.can_change:= Boolean(getFile8Bit(filea));
    change.trigger_side:= getFile8Bit(filea);
    change.trigger_player:= getFile8Bit(filea); 
    change.trigger_page:= getFile8Bit(filea);
    if change.trigger_page=CH_PAGE_ANY_FILE then change.trigger_page:=CH_PAGE_ANY
    else change.trigger_page:=(1 shl change.trigger_page);
    change.has_action:= Boolean(getFile8Bit(filea));
    change.action_type:= getFile8Bit(filea);
    change.action_mode:= getFile8Bit(filea);
    change.action_arg:= getFile16BitBE(filea);
    event_bits:= getFile8Bit(filea); (* ... bits 32 - 39 of "has_event[]" (not nice, but downward compatible) *)
    for j:=32 to Pred(NUM_CHANGE_EVENTS) do
    if (event_bits and (1 shl (j-32))) <> 0 then
     change.has_event[j]:= LongBool(1);
  end;
  ei.modified_settings:= LongBool(1); (* mark this custom element as modified *)
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_GRP1(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
element: integer;
i, x: integer;
ei: pElementInfo;
group: pElementGroupInfo;
begin
  element:= getMappedElement(getFile16BitBE(filea));
  if not IS_GROUP_ELEMENT(element) then
  begin
    Debug('ERROR: invalid group element number '+IntToStr(element));
    ReadUnusedBytesFromFile(filea,chunk_size-2);
    begin
      result:= chunk_size;
      exit;
    end;
  end;
  ei:=@element_info[element];
  ei.description:='';
  for{while} i:=0 to Pred(MAX_ELEMENT_NAME_LEN) { i++} do
  begin
    x:=getFile8Bit(filea);
    if i <> Length(ei.description) then x:=0;// one x has been skipped, skip the rest
    if x = 0 then continue;
    ei.description:= ei.description + Chr(x);
  end;
//  for i:=0 to Pred(MAX_ELEMENT_NAME_LEN) do ei.description[i+1]:= Chr(getFile8Bit(filea));
//  ei.description[MAX_ELEMENT_NAME_LEN+1]:= #0;

  group:= @element_info[element].group;
  group.num_elements:= getFile8Bit(filea);
  ei.use_gfx_element:= Boolean(getFile8Bit(filea));
  ei.gfx_element:= getMappedElement(getFile16BitBE(filea));
  group.choice_mode:= getFile8Bit(filea);
  ReadUnusedBytesFromFile(filea,3);
  (* some free bytes for future values and padding *)
  for{while} i:=0 to Pred(MAX_ELEMENTS_IN_GROUP) { i++}
  do
  group.element[i]:= getMappedElement(getFile16BitBE(filea));
  element_info[element].modified_settings:= LongBool(1); (* mark this group element as modified *)
  begin
    result:= chunk_size;
    exit;
  end;
end;

function LoadLevel_INFO(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
  real_chunk_size: integer;
begin
  real_chunk_size:=0;
  li:= {*}level^; (* copy level data into temporary buffer *)
  while not eof(filea) do
  begin
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_INFO,-1,-1));
    if real_chunk_size>=chunk_size then
     break; {<= !!!b possible in "switch" - then remove this line}
  end;
  {*}level^:=li;
  (* copy temporary buffer back to level data *)
  begin
    result:= real_chunk_size;
    exit;
  end;
end;

function LoadLevel_ELEM(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
real_chunk_size: integer;
element: integer;
begin
  real_chunk_size:=0;
  li:= {*}level^; (* copy level data into temporary buffer *)
  while not eof(filea) do
  begin
    element:=getMappedElement(getFile16BitBE(filea));
    real_chunk_size:= real_chunk_size + (2);
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_ELEM,element,element));
    if real_chunk_size>=chunk_size then
     break; {<= !!!b possible in "switch" - then remove this line}
  end;
  {*}level^:=li; (* copy temporary buffer back to level data *)
  begin
    result:= real_chunk_size;
    exit;
  end;
end;

function LoadLevel_CONF(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
real_chunk_size: integer;
element: integer;
begin
  real_chunk_size:=0;
  li:= {*}level^; (* copy level data into temporary buffer *)
  while not eof(filea) do
  begin
    element:=getMappedElement(getFile16BitBE(filea));
    real_chunk_size:= real_chunk_size + (2);
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_CONF,element,element));
    if real_chunk_size>=chunk_size then
     break; {<= !!!b possible in "switch" - then remove this line}
  end;
  {*}level^:=li; (* copy temporary buffer back to level data *)
  begin
    result:= real_chunk_size;
    exit;
  end;
end;

function LoadLevel_NOTE(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
element: integer;
envelope_nr: integer;
real_chunk_size: integer;
begin
  element:=getMappedElement(getFile16BitBE(filea));
  envelope_nr:=element-EL_ENVELOPE_1;
//  element_info[element].modified_settings:=True;
  real_chunk_size:=2;
  while not eof(filea) do
  begin
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_NOTE,-1,element));
    if real_chunk_size>=chunk_size then
     break; {<= !!!b possible in "switch" - then remove this line}
  end;
  level.envelope[envelope_nr]:= xx_envelope; 
  begin
    result:= real_chunk_size; 
    exit;
  end;
end;

function LoadLevel_CUSX(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
element: integer;
real_chunk_size: integer;
i: integer;
ei: pElementInfo;
change: pElementChangeInfo;
begin
  element:=getMappedElement(getFile16BitBE(filea));
  real_chunk_size:=2;
  ei:=@element_info[element];

  ei.description:=Copy('custom element ' + IntToStr(element-EL_CUSTOM_START+1), 1, MAX_ELEMENT_NAME_LEN);
  ei.modified_settings := true;
  xx_ei:= {*}ei^;
  xx_ei.num_change_pages:= -1; (* copy element data into temporary buffer *)
  while not eof(filea) do
  begin
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_CUSX_base,-1,element));

    if xx_ei.num_change_pages<>-1 then break;
    if real_chunk_size>=chunk_size then break;
  end;
  ei^:=xx_ei;
  if ei.num_change_pages=-1 then
  begin
    Debug('ERROR: LoadLevel_CUSX(): missing '#39'num_change_pages'#39' for '#39+EL_NAME(element)+#39'');
    ei.num_change_pages:= 1;
    setElementChangePages(ei,1);
    setElementChangeInfoToDefaults(ei.change);
    begin
      result:= real_chunk_size;
      exit;
    end;
  end;

  setElementChangePages(ei,ei.num_change_pages);
  (* initialize number of change pages stored for this custom element *)
  for i:=0 to Pred(ei.num_change_pages) do
   setElementChangeInfoToDefaults(@ei.change_page[i]);
  xx_current_change_page:= 0; (* start with reading properties for the first change page *)
  while not eof(filea) do
  begin
    change:=@ei.change_page[xx_current_change_page];// refresh change page in case of a xx_current_change_page change in micro chunk
    xx_change:=change^;
    resetEventBits();
    (* copy change data into temporary buffer *)
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_CUSX_change,-1,element));
    change^:=xx_change;
    setEventFlagsFromEventBits(change);
    (* reset bits; change page might have changed *)
    if real_chunk_size>=chunk_size then
    break; {<= !!!b possible in "switch" - then remove this line}
  end;
  begin
    result:= real_chunk_size;
    exit;
  end;
end;

function LoadLevel_GRPX(var filea: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
var
element: integer;

real_chunk_size: integer;
ei: pElementInfo;
group: pElementGroupInfo;
begin
  element:=getMappedElement(getFile16BitBE(filea));
  real_chunk_size:=2;
  ei:=@element_info[element];
  ei.modified_settings := true;// just a way to check if the GE has been used
  group:=@ei.group;

  xx_ei:= {*}ei^;
  xx_group:= {*}group^; (* copy element data into temporary buffer *)
  (* copy group data into temporary buffer *)
  while not eof(filea) do
  begin
    real_chunk_size:= real_chunk_size + (LoadLevel_MicroChunk(filea,chunk_config_GRPX,-1,element));
    if real_chunk_size>=chunk_size then
    break; {<= !!!b possible in "switch" - then remove this line}
  end;
  {*}ei^:=xx_ei;
  {*}group^:=xx_group;
  begin
    result:= real_chunk_size;
    exit;
  end;
end;

function LoadLevelFromFileInfo_RND(level: pLevelInfo; var elements: ElemInfoArr; filename: string): boolean;
var
cookie: string;
chunk_name: string;
chunk_size: integer;
i: integer;
chunk_size_expected: integer;
 (* the size of some chunks cannot be checked before reading other
    chunks first (like "HEAD" and "BODY") that contain some header
    information, so check them here *)
type
  TChunkLoader = function (var f: TByteFile;  chunk_size: integer;  level: pLevelInfo): integer;
  CChunkInfo = record
    name: String;
    size: longint;
    loader: TChunkLoader;
  end;
const
  chunk_info: array [0..20] of CChunkInfo =
  ((name: 'VERS'; size: LEVEL_CHUNK_VERS_SIZE;  loader: LoadLevel_VERS),
   (name: 'DATE'; size: LEVEL_CHUNK_DATE_SIZE;  loader: LoadLevel_DATE),
   (name: 'HEAD'; size: LEVEL_CHUNK_HEAD_SIZE;  loader: LoadLevel_HEAD),
   (name: 'NAME'; size: LEVEL_CHUNK_NAME_SIZE;  loader: LoadLevel_NAME),
   (name: 'AUTH'; size: LEVEL_CHUNK_AUTH_SIZE;  loader: LoadLevel_AUTH),
   (name: 'INFO'; size: -1;  loader: LoadLevel_INFO),
   (name: 'BODY'; size: -1;  loader: LoadLevel_BODY),
   (name: 'CONT'; size: -1;  loader: LoadLevel_CONT),
   (name: 'CNT2'; size: LEVEL_CHUNK_CNT2_SIZE; loader: LoadLevel_CNT2),
   (name: 'CNT3'; size: -1;  loader: LoadLevel_CNT3),
   (name: 'CUS1'; size: -1;  loader: LoadLevel_CUS1),
   (name: 'CUS2'; size: -1;  loader: LoadLevel_CUS2),
   (name: 'CUS3'; size: -1;  loader: LoadLevel_CUS3),
   (name: 'CUS4'; size: -1;  loader: LoadLevel_CUS4),
   (name: 'GRP1'; size: -1;  loader: LoadLevel_GRP1),
   (name: 'CONF'; size: -1;  loader: LoadLevel_CONF),
   (name: 'ELEM'; size: -1;  loader: LoadLevel_ELEM),
   (name: 'NOTE'; size: -1;  loader: LoadLevel_NOTE),
   (name: 'CUSX'; size: -1;  loader: LoadLevel_CUSX),
   (name: 'GRPX'; size: -1;  loader: LoadLevel_GRPX),
   (name: '';     size: 0;                     loader: nil));
begin
  element_info:=elements;
  Result:=False;
  if not FileExists(filename) then
  begin
    level.no_valid_file:= LongBool(1);
//    if level<>@level_template then// ***ZZZ*** use level_template?
    Debug('ERROR: cannot read level '#39+filename+#39);
    exit;
  end;
  chunknames:='';
  chunk_name:='';
  AssignFile(filea, filename);
  Reset(filea);
  try
  try
  getFileChunkBE(filea,chunk_name,nil);
  if chunk_name = 'RND1' then
  begin
    getFile32BitBE(filea);
    getFileChunkBE(filea,chunk_name,nil);
    (* not used *)
    if chunk_name <> 'CAVE' then
    begin
      level.no_valid_file:= LongBool(1);
      Debug('ERROR: unknown format of level filea '#39+filename+#39);
      CloseFile(filea);
      exit;
    end;
    level.file_version:=VERSION_IDENT(2,0,0,0);
  end
  else
  begin
    (* check for pre-2.0 file format with cookie string *)
    cookie:=chunk_name;
// original:   fgets(&cookie[4],MAX_LINE_LEN-4,filea);
// SNDIAMONDS_LEVEL_FILE_VERSION_1.4#0A (length 34)
    cookie:=cookie + ReadCount(34, filea);
    if (length(cookie)>0)and(cookie[length(cookie)-1]=#10) then
    cookie[length(cookie)-1]:=#0;
    if GetTextAfter(cookie, '_FILE_VERSION_') = '' then
    begin
      level.no_valid_file:= True;
      Debug('ERROR: unsupported version of level file '#39+filename+#39);
      closefile(filea);
      exit;
    end
    else// level.file_version:=getFileVersionFromCookieString(cookie)
     level.file_version:=VERSION_IDENT(1,
       strtoint(Copy(cookie, LastDelimiter('.', cookie)+1, 1)),0,0);
    level.game_version:= level.file_version;
    (* pre-2.0 level files have no game version, so use file version here *)
  end;

  if level.file_version<FILE_VERSION_1_2 then
  begin
    (* level files from versions before 1.2.0 without chunk structure *)
    LoadLevel_HEAD(filea,LEVEL_CHUNK_HEAD_SIZE,level);
    LoadLevel_BODY(filea,level.fieldx*level.fieldy,level);
    chunknames:=' no chunks (old style level)';
  end
  else
  begin
    chunk_size:=0;
    while getFileChunkBE(filea,chunk_name, @chunk_size) do
    begin
      chunknames:=chunknames + ',' + chunk_name;
      i:=0;
      while (chunk_info[i].name<>'') and (chunk_name <> chunk_info[i].name) do inc(i);
      if chunk_info[i].name='' then
      begin
        Debug('ERROR: unknown chunk "' + chunk_name + '" in level file "' + filename + '" at filepos ' + IntToStr(FilePos(filea)));
        ReadUnusedBytesFromFile(filea,chunk_size);
      end
      else if (chunk_info[i].size<>-1)and(chunk_info[i].size<>chunk_size) then
      begin
        Debug('ERROR: wrong size (' + IntToStr(chunk_size) + ') of chunk "' + chunk_name + '" in level file "' + filename + '" at filepos ' + IntToStr(FilePos(filea)));
        ReadUnusedBytesFromFile(filea,chunk_size);
      end
      else
      begin
        (* call function to load this level chunk *)
        chunk_size_expected:=(chunk_info[i].loader(filea,chunk_size,level));
        if chunk_size_expected<>chunk_size then
        begin
          Debug('ERROR: wrong size ('+inttostr(chunk_size)+') of chunk "' +
           chunk_name + '" in level file "' + filename + '"');
        end;
      end;
    end;
    Result:=True;
  end;
  except
    on E: Exception do
    begin
      Debug('ERROR: Load exception: ' + E.Message +
      '; ' + FileName + ', filepos ' + IntToStr(FilePos(filea)) + ', chunkname ' + chunk_name);
    end;
  end;
  finally
    CloseFile(filea);
    Delete(chunknames, 1, 1);// delete first comma
  end;
// init a lot of stuff...
  LoadLevel_InitVersion(level, filename);
  LoadLevel_InitElements(level, filename);
  elements:=element_info;// transport element info from loading variable to script variable
end;

{LEVEL_CHUNK_CNT3_SIZE(x)  (LEVEL_CHUNK_CNT3_HEADER + (x))}
function LEVEL_CHUNK_CNT3_SIZE(x: integer): integer;
begin
  result:= (LEVEL_CHUNK_CNT3_HEADER+(x))
end;

{LEVEL_CHUNK_CUS3_SIZE(x)  (2 + (x) * LEVEL_CPART_CUS3_SIZE)}
function LEVEL_CHUNK_CUS3_SIZE(x: integer): integer;
begin
  result:= (2+(x)*LEVEL_CPART_CUS3_SIZE)
end;

{LEVEL_CHUNK_CUS4_SIZE(x)  (96 + (x) * 48)}
function LEVEL_CHUNK_CUS4_SIZE(x: integer): integer;
begin
  result:= (96+(x)*48)
end;

function SaveLevel_VERS(var f: TByteFile;  level: pLevelInfo): integer;
var
  chunk_size: integer;
begin
  chunk_size:=0;
  chunk_size:= chunk_size + (putFileVersion(f,level.file_version));
  chunk_size:= chunk_size + (putFileVersion(f,level.game_version));
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_DATE(var f: TByteFile;  level: pLevelInfo): integer;
var
  chunk_size: integer;
begin
  chunk_size:=0;
  chunk_size:= chunk_size + (putFile16BitBE(f,level.creation_date.year));
  chunk_size:= chunk_size + (putFile8Bit(f,level.creation_date.month));
  chunk_size:= chunk_size + (putFile8Bit(f,level.creation_date.day));
  result:= chunk_size;
end;

function SaveLevel_NAME(var f: TByteFile;  level: pLevelInfo): integer;
var
chunk_size: integer;
i: integer;
begin
  chunk_size:=0;
  for i:=0 to Pred(MAX_LEVEL_NAME_LEN) do
  if i < Length(level.name) then
   chunk_size:= chunk_size + (putFile8Bit(f,ord(level.name[i+1])))
  else chunk_size:= chunk_size + putFile8Bit(f,0);
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_AUTH(var f: TByteFile;  level: pLevelInfo): integer;
var
chunk_size: integer;
i: integer;
begin
  chunk_size:=0;
  for i:=0 to Pred(MAX_LEVEL_AUTHOR_LEN) do
  if i < Length(level.author) then
   chunk_size:= chunk_size + (putFile8Bit(f,ord(level.author[i+1])))
  else chunk_size:= chunk_size + putFile8Bit(f,0);
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_BODY(var f: TByteFile;  level: pLevelInfo): integer;
var
chunk_size: integer;
x: integer;
y: integer;
begin
  chunk_size:=0;
  for y:=0 to Pred(level.fieldy) do
  for x:=0 to Pred(level.fieldx) do
   chunk_size:= chunk_size + (putFile16BitBE(f,level.field[x][y]));
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_INFO(var f: TByteFile;  level: pLevelInfo): integer;
var
  chunk_size: integer;
  i: integer;
begin
  chunk_size:=0;
  li:= level^; (* copy level data into temporary buffer *)
  i:= 0;
  for i:=0 to High(chunk_config_INFO) do
  if chunk_config_INFO[i].data_type = -1 then break
  else chunk_size:= chunk_size + (SaveLevel_MicroChunk(f, @chunk_config_INFO[i],LongBool(0)));
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_ELEM(var f: TByteFile;  level: pLevelInfo): integer;
var
chunk_size: integer;
i: integer;
begin
  chunk_size:=0;
  li:= level^; (* copy level data into temporary buffer *)
  for i:=0 to High(chunk_config_ELEM) do
  if chunk_config_ELEM[i].data_type = -1 then break
  else chunk_size:= chunk_size + (SaveLevel_MicroChunk(f, @chunk_config_ELEM[i],LongBool(1)));
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_NOTE(var f: TByteFile;  level: pLevelInfo;  element: integer): integer;
var
envelope_nr: integer;
chunk_size: integer;
i: integer;
begin
  envelope_nr:=element-EL_ENVELOPE_1;
  chunk_size:=0;
  chunk_size:= chunk_size + (putFile16BitBE(f,element));
  xx_envelope:= level.envelope[envelope_nr]; (* copy envelope data into temporary buffer *)
  for i:=0 to High(chunk_config_NOTE) do
  if chunk_config_NOTE[i].data_type = -1 then break
  else chunk_size:= chunk_size + (SaveLevel_MicroChunk(f, @chunk_config_NOTE[i],LongBool(0)));
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_CUSX(var f: TByteFile;  level: pLevelInfo;  element: integer): integer;
var
chunk_size: integer;
i: integer;
j: integer;
ei: pElementInfo;
change: pElementChangeInfo;
begin
  ei:=@element_info[element];
  chunk_size:=0;
  chunk_size:= chunk_size + (putFile16BitBE(f,element));
  xx_ei:= ei^; (* copy element data into temporary buffer *)

  // make sure correct default desciption is set
  ei.editor_description:='custom element ' + IntToStr(element-EL_CUSTOM_START+1);

  (* set default description string for this specific element *)
  xx_default_description:=getDefaultElementDescription(ei);

  (* set (fixed) number of content areas (may be wrong by broken level file) *)
  (* (this is now directly corrected for broken level files after loading) *)
//  xx_num_contents:= 1;

  for i:=0 to High(chunk_config_CUSX_base) do
  if chunk_config_CUSX_base[i].data_type = -1 then break
  else chunk_size:= chunk_size + (SaveLevel_MicroChunk(f, @chunk_config_CUSX_base[i],LongBool(0)));

  for i:=0 to Pred(ei.num_change_pages) do
  begin
    change:=@ei.change_page[i];
    xx_current_change_page:= i;
    xx_change:= change^;
    resetEventBits();
    (* copy change data into temporary buffer *)
    setEventBitsFromEventFlags(change);

    for j:=0 to High(chunk_config_CUSX_change) do
    if chunk_config_CUSX_change[j].data_type = -1 then break
    else chunk_size:= chunk_size + (SaveLevel_MicroChunk(f, @chunk_config_CUSX_change[j],LongBool(0)));
  end;
  begin
    result:= chunk_size;
    exit;
  end;
end;

function SaveLevel_GRPX(var f: TByteFile;  level: pLevelInfo;  element: integer): integer;
var
chunk_size: integer;
i: integer;
ei: pElementInfo;
group: pElementGroupInfo;
begin
  ei:=@element_info[element];
  group:=@ei.group;
  chunk_size:=0;
  chunk_size:= chunk_size + (putFile16BitBE(f,element));
  xx_ei:= ei^;
  xx_group:= group^;
  xx_default_description:=getDefaultElementDescription(ei);
  (* copy element data into temporary buffer *)
  (* copy group data into temporary buffer *)
  (* set default description string for this specific element *)
  for i:=0 to High(chunk_config_GRPX) do
  if chunk_config_GRPX[i].data_type = -1 then break
  else chunk_size:= chunk_size + (SaveLevel_MicroChunk(f, @chunk_config_GRPX[i],LongBool(0)));
  begin
    result:= chunk_size;
    exit;
  end;
end;

procedure SaveLevelFromFilename(level: pLevelInfo;  filename: pchar);
var
chunk_size: integer;
i: integer;
f, tmp: TByteFile;
element: integer;
begin
  element_info:=elements1;// make sure to save correct level
  AssignFile(F, filename);
  Rewrite(F);
  AssignFile(tmp, 'temp.cescripter.level');
  Rewrite(tmp);
//  if {not}0=(file:=fopen(filename,MODE_WRITE))
  if false then// use exceptions somehow to check for errors when saving files
  begin
    Debug('ERROR: cannot save level "' + filename + '"');
    exit;
  end;
  level.file_version:= FILE_VERSION_ACTUAL;
  level.game_version:= GAME_VERSION_ACTUAL;
  level.creation_date.day:=StrToInt(FormatDateTime('d',Date));
  level.creation_date.month:=StrToInt(FormatDateTime('m',Date));
  level.creation_date.year:=StrToInt(FormatDateTime('yyyy',Date));
  putFileChunkBE(f,'RND1',CHUNK_SIZE_UNDEFINED);
  putFileChunkBE(f,'CAVE',CHUNK_SIZE_NONE);
  chunk_size:= SaveLevel_VERS(tmp,level);
  putFileChunkBE(f,'VERS',chunk_size);
  SaveLevel_VERS(f,level);
  chunk_size:= SaveLevel_DATE(tmp,level);
  putFileChunkBE(f,'DATE',chunk_size);
  SaveLevel_DATE(f,level);
  chunk_size:= SaveLevel_NAME(tmp,level);
  putFileChunkBE(f,'NAME',chunk_size);
  SaveLevel_NAME(f,level);
  chunk_size:= SaveLevel_AUTH(tmp,level);
  putFileChunkBE(f,'AUTH',chunk_size);
  SaveLevel_AUTH(f,level);
  chunk_size:= SaveLevel_INFO(tmp,level);
  putFileChunkBE(f,'INFO',chunk_size);
  SaveLevel_INFO(f,level);
  chunk_size:= SaveLevel_BODY(tmp,level);
  putFileChunkBE(f,'BODY',chunk_size);
  SaveLevel_BODY(f,level);
  chunk_size:= SaveLevel_ELEM(tmp,level);
  if chunk_size>LEVEL_CHUNK_ELEM_UNCHANGED then
  begin
    (* save if changed *)
    putFileChunkBE(f,'ELEM',chunk_size);
    SaveLevel_ELEM(f,level);
  end;
  for i:=0 to Pred(NUM_ENVELOPES) do
  begin
    element:=EL_ENVELOPE_1+i;
    chunk_size:= SaveLevel_NOTE(tmp,level,element);
    if chunk_size>LEVEL_CHUNK_NOTE_UNCHANGED then
    begin
      (* save if changed *)
      putFileChunkBE(f,'NOTE',chunk_size);
      SaveLevel_NOTE(f,level,element);
    end;
  end;
  (* if not using template level, check for non-default custom/group elements *)
  if not level.use_custom_template then
  begin
    for{while} i:=0 to Pred(NUM_CUSTOM_ELEMENTS) { i++} do
    begin
      element:=EL_CUSTOM_START+i;
      chunk_size:= SaveLevel_CUSX(tmp,level,element);
      if chunk_size>LEVEL_CHUNK_CUSX_UNCHANGED then
      begin
        (* save if changed *)
        putFileChunkBE(f,'CUSX',chunk_size);
        SaveLevel_CUSX(f,level,element);
      end;
    end;
    for{while} i:=0 to Pred(NUM_GROUP_ELEMENTS) { i++} do
    begin
      element:=EL_GROUP_START+i;
      chunk_size:= SaveLevel_GRPX(tmp,level,element);
      if chunk_size>LEVEL_CHUNK_GRPX_UNCHANGED then
      begin
        (* save if changed *)
        putFileChunkBE(f,'GRPX',chunk_size);
        SaveLevel_GRPX(f,level,element);
      end;
    end;
  end;
  closefile(f);
  modifiedlevel:=False;
  closefile(tmp);
  Debug('File saved to ' + strpas(filename), OUTPUT_NOPROCESSING);
//  SetFilePermissions(filename,PERMS_PRIVATE);
end;

end.
