unit misc_fromsource;

{$MODE Delphi}

interface

const
  FONT_ASCII_CURSOR	= chr(160);
  MAX_LINE_LEN = 1024;
const
(* values for getFile...() and putFile...() *)
BYTE_ORDER_BIG_ENDIAN	= 0;
BYTE_ORDER_LITTLE_ENDIAN = 1;

const
ERR_RETURN = 0;
ERR_RETURN_LINE = (1 shl 0);
ERR_WARN = (1 shl 1);
ERR_EXIT = (1 shl 2);
ERR_HELP = (1 shl 3);
ERR_SOUND_SERVER = (1 shl 4);
ERR_NETWORK_SERVER = (1 shl 5);
ERR_NETWORK_CLIENT = (1 shl 6);
ERR_FROM_SERVER = (ERR_SOUND_SERVER or ERR_NETWORK_SERVER);
ERR_EXIT_HELP = (ERR_EXIT or ERR_HELP);
ERR_EXIT_SOUND_SERVER = (ERR_EXIT or ERR_SOUND_SERVER);
ERR_EXIT_NETWORK_SERVER = (ERR_EXIT or ERR_NETWORK_SERVER);
ERR_EXIT_NETWORK_CLIENT = (ERR_EXIT or ERR_NETWORK_CLIENT);

const
MAX_PLAYER_NAME_LEN = 10;
MAX_PLAYERS = 4;
NAMELESS_LEVEL_NAME = 'nameless level';
ANONYMOUS_NAME = 'anonymous';
MAX_FILENAME_LEN = 256;
(* values for move directions *)
const
MV_BIT_LEFT = 0;
MV_BIT_RIGHT = 1;
MV_BIT_UP = 2;
MV_BIT_DOWN = 3;
NUM_DIRECTIONS = 4;
(* values for special "button" bitmasks *)
BUTTON_1 = 4;
BUTTON_2 = 5;

(* values for move direction and special "button" key bitmasks *)
MV_NONE = 0;
MV_LEFT = (1 shl MV_BIT_LEFT);
MV_RIGHT = (1 shl MV_BIT_RIGHT);
MV_UP = (1 shl MV_BIT_UP);
MV_DOWN = (1 shl MV_BIT_DOWN);
MV_UPLEFT = (MV_UP or MV_LEFT);
MV_UPRIGHT = (MV_UP or MV_RIGHT);
MV_DOWNLEFT = (MV_DOWN or MV_LEFT);
MV_DOWNRIGHT = (MV_DOWN or MV_RIGHT);
MV_HORIZONTAL = (MV_LEFT or MV_RIGHT);
MV_VERTICAL = (MV_UP or MV_DOWN);
MV_ALL_DIRECTIONS = (MV_LEFT or MV_RIGHT or MV_UP or MV_DOWN);
MV_ANY_DIRECTION = (MV_ALL_DIRECTIONS);
MV_NO_DIRECTION = (MV_NONE);


(* values for animation mode (frame order and direction) *)
ANIM_NONE = 0;
ANIM_LOOP = (1 shl 0);
ANIM_LINEAR = (1 shl 1);
ANIM_PINGPONG = (1 shl 2);
ANIM_PINGPONG2 = (1 shl 3);
ANIM_RANDOM = (1 shl 4);
ANIM_REVERSE = (1 shl 5);
(* values for special (non game element) animation modes *)
ANIM_HORIZONTAL = (1 shl 6);
ANIM_VERTICAL = (1 shl 7);
ANIM_DEFAULT = ANIM_LOOP;

function MV_DIR_BIT(x: integer): integer; {<= !!!6 unknown macro}
function MV_DIR_OPPOSITE(x: integer): integer; {<= !!!6 unknown macro}
function VERSION_MAJOR(x: integer): integer; {<= !!!6 unknown macro}
function VERSION_MINOR(x: integer): integer; {<= !!!6 unknown macro}
function VERSION_PATCH(x: integer): integer; {<= !!!6 unknown macro}
function VERSION_BUILD(x: integer): integer; {<= !!!6 unknown macro}
function VERSION_IDENT(a: integer; b: integer; c: integer; d: integer): integer; {<= !!!6 unknown macro}
function MAP_FONT_ASCII(c: char): integer;
function checkCookieString(const cookie: string; const template: string): Boolean;

(* sort priorities of level series (also used as level series classes) *)
const
LEVELCLASS_TUTORIAL_START = 10;
LEVELCLASS_TUTORIAL_END = 99;
LEVELCLASS_CLASSICS_START = 100;
LEVELCLASS_CLASSICS_END = 199;
LEVELCLASS_CONTRIB_START = 200;
LEVELCLASS_CONTRIB_END = 299;
LEVELCLASS_PRIVATE_START = 300;
LEVELCLASS_PRIVATE_END = 399;
LEVELCLASS_BD_START = 400;
LEVELCLASS_BD_END = 499;
LEVELCLASS_EM_START = 500;
LEVELCLASS_EM_END = 599;
LEVELCLASS_SP_START = 600;
LEVELCLASS_SP_END = 699;
LEVELCLASS_DX_START = 700;
LEVELCLASS_DX_END = 799;
LEVELCLASS_PREDEFINED_START = LEVELCLASS_TUTORIAL_START;
LEVELCLASS_PREDEFINED_END = LEVELCLASS_DX_END;
LEVELCLASS_TUTORIAL = LEVELCLASS_TUTORIAL_START;
LEVELCLASS_CLASSICS = LEVELCLASS_CLASSICS_START;
LEVELCLASS_CONTRIB = LEVELCLASS_CONTRIB_START;
LEVELCLASS_PRIVATE = LEVELCLASS_PRIVATE_START;
LEVELCLASS_BD = LEVELCLASS_BD_START;
LEVELCLASS_EM = LEVELCLASS_EM_START;
LEVELCLASS_SP = LEVELCLASS_SP_START;
LEVELCLASS_DX = LEVELCLASS_DX_START;
LEVELCLASS_UNDEFINED = 999;

function IS_LEVELCLASS_TUTORIAL(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_CLASSICS(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_CONTRIB(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_PRIVATE(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_BD(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_EM(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_SP(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_DX(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function IS_LEVELCLASS_UNDEFINED(sort_priority: Integer): boolean; {<= !!!6 unknown macro}
function LEVELCLASS(sort_priority: Integer): integer; {<= !!!6 unknown macro}
function log_2(x: Longword): Integer;

implementation

uses main_h;

function log_2(x: Longword): Integer;
var
  e: integer;
begin
  e:=0;
  while ((1 shl e) < x) do
  begin
    x:=x - (1 shl e);
// for rounding down (rounding up: remove this line)
    e:=e+1;
  end;
  Result:=e;
end;

function checkCookieString(const cookie: string; const template: string): Boolean;
const
//  pattern = '_FILE_VERSION_?.?';
  pattern = '_FILE_VERSION_';
var
  len_cookie, len_template: word;
//   len_pattern: word;
begin
  len_cookie:=length(cookie);
  len_template:=length(template);
//  len_pattern:=length(pattern);

  if (len_cookie <> len_template) then Result:=false
  else if pos(pattern, cookie) <> 0 then Result:=False
//  else if (copy(cookie, 1, len_cookie-len_pattern)
//   = copy(cookie, 1, len_cookie-len_pattern)) then Result:=False
   else Result:=True;
//  if (strncmp(cookie, template, len_cookie - len_pattern) != 0)
//    return FALSE;
end;

function MAP_FONT_ASCII(c: char): integer;
begin
  if (c >= 'a') and (c <= 'z') then
   Result:=Ord('A') + Ord(c) - Ord('a')
  else if (c) = '' then Result:=96
  else if (c = '') or (c = '') then Result:=97
  else if (c = '') or (c = '') then Result:=98
  else if (c = '') or (c = '') then Result:=99
  else if (c = '') then Result:=100
  else if (c = '') then Result:=101
  else if (c = FONT_ASCII_CURSOR) then Result:=102
  else Result:=Ord(c);
end;

{MV_DIR_BIT(x)  ((x) == MV_LEFT  ? MV_BIT_LEFT  :      (x) == MV_RIGHT ? MV_BIT_RIGHT :      (x) == MV_UP    ? MV_BIT_UP    : MV_BIT_DOWN)}
function MV_DIR_BIT(x: integer): integer;
begin
  if x = MV_LEFT then Result:=MV_BIT_LEFT
  else if x = MV_RIGHT then Result:=MV_BIT_RIGHT
  else if x = MV_UP then Result:=MV_BIT_UP
  else Result:=MV_BIT_DOWN;
end;

{MV_DIR_OPPOSITE(x) ((x) == MV_LEFT  ? MV_RIGHT :       (x) == MV_RIGHT ? MV_LEFT  :       (x) == MV_UP    ? MV_DOWN  :       (x) == MV_DOWN  ? MV_UP    : MV_NO_MOVING)}
function MV_DIR_OPPOSITE(x: integer): integer;
begin
  case x of
    MV_LEFT: Result:=MV_RIGHT;
    MV_RIGHT: Result:=MV_LEFT;
    MV_UP: Result:=MV_DOWN;
    MV_DOWN: Result:=MV_UP;
    else Result:=MV_NONE;
  end;
end;

{VERSION_MAJOR(x) ((x) / 1000000)}
function VERSION_MAJOR(x: integer): integer;
begin
  result:= ((x) div 1000000)
end;

{VERSION_MINOR(x) (((x) % 1000000) / 10000)}
function VERSION_MINOR(x: integer): integer;
begin
  result:= (((x) mod 1000000) div 10000)
end;

{VERSION_PATCH(x) (((x) % 10000) / 100)}
function VERSION_PATCH(x: integer): integer;
begin
  result:= (((x) mod 10000) div 100)
end;

{VERSION_BUILD(x) ((x) % 100)}
function VERSION_BUILD(x: integer): integer;
begin
  result:= ((x) mod 100)
end;

{VERSION_IDENT(a,b,c,d) ((a) * 1000000 + (b) * 10000 + (c) * 100 + (d)) }
function VERSION_IDENT(a: integer; b: integer; c: integer; d: integer): integer;
begin
  result:= ((a)*1000000+(b)*10000+(c)*100+(d))
end;

{ LEVELCLASSES }
{IS_LEVELCLASS_TUTORIAL(p)      ((p)->sort_priority >= LEVELCLASS_TUTORIAL_START &&    (p)->sort_priority <= LEVELCLASS_TUTORIAL_END)}
function IS_LEVELCLASS_TUTORIAL(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_TUTORIAL_START)and(sort_priority<=LEVELCLASS_TUTORIAL_END)
end;

{IS_LEVELCLASS_CLASSICS(p)      ((p)->sort_priority >= LEVELCLASS_CLASSICS_START &&    (p)->sort_priority <= LEVELCLASS_CLASSICS_END)}
function IS_LEVELCLASS_CLASSICS(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_CLASSICS_START)and(sort_priority<=LEVELCLASS_CLASSICS_END)
end;

{IS_LEVELCLASS_CONTRIB(p)      ((p)->sort_priority >= LEVELCLASS_CONTRIB_START &&    (p)->sort_priority <= LEVELCLASS_CONTRIB_END)}
function IS_LEVELCLASS_CONTRIB(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_CONTRIB_START)and(sort_priority<=LEVELCLASS_CONTRIB_END)
end;

{IS_LEVELCLASS_PRIVATE(p)      ((p)->sort_priority >= LEVELCLASS_PRIVATE_START &&    (p)->sort_priority <= LEVELCLASS_PRIVATE_END)}
function IS_LEVELCLASS_PRIVATE(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_PRIVATE_START)and(sort_priority<=LEVELCLASS_PRIVATE_END)
end;

{IS_LEVELCLASS_BD(p)       ((p)->sort_priority >= LEVELCLASS_BD_START &&     (p)->sort_priority <= LEVELCLASS_BD_END)}
function IS_LEVELCLASS_BD(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_BD_START)and(sort_priority<=LEVELCLASS_BD_END)
end;

{IS_LEVELCLASS_EM(p)       ((p)->sort_priority >= LEVELCLASS_EM_START &&     (p)->sort_priority <= LEVELCLASS_EM_END)}
function IS_LEVELCLASS_EM(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_EM_START)and(sort_priority<=LEVELCLASS_EM_END)
end;

{IS_LEVELCLASS_SP(p)       ((p)->sort_priority >= LEVELCLASS_SP_START &&     (p)->sort_priority <= LEVELCLASS_SP_END)}
function IS_LEVELCLASS_SP(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_SP_START)and(sort_priority<=LEVELCLASS_SP_END)
end;

{IS_LEVELCLASS_DX(p)       ((p)->sort_priority >= LEVELCLASS_DX_START &&     (p)->sort_priority <= LEVELCLASS_DX_END)}
function IS_LEVELCLASS_DX(sort_priority: Integer): boolean;
begin
  result:= (sort_priority>=LEVELCLASS_DX_START)and(sort_priority<=LEVELCLASS_DX_END)
end;

{IS_LEVELCLASS_UNDEFINED(p)      ((p)->sort_priority < LEVELCLASS_PREDEFINED_START ||    (p)->sort_priority > LEVELCLASS_PREDEFINED_END)}
function IS_LEVELCLASS_UNDEFINED(sort_priority: Integer): boolean;
begin
  result:= (sort_priority<LEVELCLASS_PREDEFINED_START)or(sort_priority>LEVELCLASS_PREDEFINED_END)
end;

{LEVELCLASS(n) (IS_LEVELCLASS_TUTORIAL(n) ? LEVELCLASS_TUTORIAL :     IS_LEVELCLASS_CLASSICS(n) ? LEVELCLASS_CLASSICS :     IS_LEVELCLASS_CONTRIB(n) ? LEVELCLASS_CONTRIB :       IS_LEVELCLASS_PRIVATE(n) ? LEVELCLASS_PRIVATE :       IS_LEVELCLASS_BD(n) ? LEVELCLASS_BD :         IS_LEVELCLASS_EM(n) ? LEVELCLASS_EM :         IS_LEVELCLASS_SP(n) ? LEVELCLASS_SP :         IS_LEVELCLASS_DX(n) ? LEVELCLASS_DX :         LEVELCLASS_UNDEFINED)}
function LEVELCLASS(sort_priority: Integer): integer;
begin
  if IS_LEVELCLASS_TUTORIAL(sort_priority) then Result:=LEVELCLASS_TUTORIAL
  else if IS_LEVELCLASS_CLASSICS(sort_priority) then Result:=LEVELCLASS_CLASSICS
  else if IS_LEVELCLASS_CONTRIB(sort_priority) then Result:=LEVELCLASS_CONTRIB
  else if IS_LEVELCLASS_PRIVATE(sort_priority) then Result:=LEVELCLASS_PRIVATE
  else if IS_LEVELCLASS_BD(sort_priority) then Result:=LEVELCLASS_BD
  else if IS_LEVELCLASS_EM(sort_priority) then Result:=LEVELCLASS_EM
  else if IS_LEVELCLASS_SP(sort_priority) then Result:=LEVELCLASS_SP
  else if IS_LEVELCLASS_DX(sort_priority) then Result:=LEVELCLASS_DX
  else Result:=LEVELCLASS_UNDEFINED
end;

end.
