unit script1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, main_h, Dialogs, Math, chunk_confs, rndtypes, md5, Graphics,
  Forms, StdCtrls, Spin, Controls, Buttons,
  Types, LResources, LCLIntf, LCLType, LCLProc,
  GraphType, ExtCtrls;
//  Windows, Messages, {Consts, }Math, Types, Spin;

procedure Script_OnUses;
function IntToStrLen(const I: Integer; const Len: Integer): String;
procedure ShowMessageScr(const aMsg: string);

implementation

uses RNDCE1, files_c;

function IntToStrLen(const I: Integer; const Len: Integer): String;
begin
  Result:=IntToStr(I);
  while Length(Result) < Len do
   Result:='0'+Result;
end;

function GetAveCharSize(Canvas: TCanvas): TPoint;
begin
  Result.X:=8;
  Result.Y:=8;
end;

function MulDiv(nNumber:longint; nNumerator:longint; nDenominator:longint):longint;
begin
  Result:=nNumber * nNumerator div nDenominator;
end;

var
  Avg : TPoint;

function CreateDialogForm(const InputCaption, InputPrompt: String): TForm;
const
  AVGBuffer : PChar = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890()|_ ';
var
  Form : TForm;
  Prompt : TLabel;
  ButtonTop, ButtonWidth, ButtonHeight : Integer;
begin
  Form := TForm.CreateNew(nil, 0);
  With Form do
  begin
    BorderStyle := bsDialog;
    Caption := InputCaption;
    if InputPrompt <> '' then
    begin
      Prompt := TLabel.Create(Form);
      with Prompt do
      begin
        Parent := Form;
        Caption := InputPrompt;
        Visible := True;
      end;
    end;
    SelectObject(Canvas.Handle, GetStockObject(DEFAULT_GUI_FONT));
    GetTextExtentPoint(Canvas.Handle,AVGBuffer,StrLen(AVGBuffer),TSize(AVG));
    AVG.X := AVG.X div 52;
    Position := poScreenCenter;
    if InputPrompt <> '' then
    begin
      Prompt.Left := (7*AVG.X) div 4;
      Prompt.Top := (8*AVG.Y) div 8;
      Prompt.Width := AVG.X * Length(InputPrompt) + 1;
    end;
    ClientWidth := (172*AVG.X) div 4;
    ClientHeight := (58*AVG.Y) div 8;
    ButtonTop := (39*AVG.Y) div 8;
    ButtonWidth := (50*AVG.X) div 4;
    ButtonHeight := 2*AVG.Y;
    // upon show, the edit control will be focused for editing, because it's
    // the first in the tab order
    with TBitBtn.Create(Form) do
    begin
      Parent := Form;
      Kind := bkOk;
      Default := True;
      ModalResult := mrOk;
      Left := (37*AVG.X) div 4;
      Top := ButtonTop;
      Height := ButtonHeight;
      Width := ButtonWidth;
      TabStop := True;
      Visible := True;
      TabOrder := 1;
    end;
    with TBitBtn.Create(Form) do
    begin
      Parent := Form;
      Kind := bkCancel;
      Cancel := True;
      Left := (92*AVG.X) div 4;
      Top := ButtonTop;
      Height := ButtonHeight;
      Width := ButtonWidth;
      TabStop := True;
      Visible := True;
      TabOrder := 2;
    end;
  end;
  Result:=Form;
end;

function InputChoice(const ACaption, APrompt: string;
  var AValue: String; Choises: array of string; var Isinlist: Boolean): Boolean;
var
  Form: TForm;
  Edit: TCombobox;
  I: Integer;
begin
  Result := False;
  Isinlist:=False;
  Form := CreateDialogForm(ACaption, APrompt);
  with Form do
  try
    Edit := TCombobox.Create(Form);
    With Edit do begin
      Parent := Form;
      Left := (7*AVG.X) div 4;
      Top := (19*AVG.Y) div 8;
      Width := (160*AVG.X) div 4;
      Height := (7*AVG.Y) div 4;
      MaxLength := 255;
      for I:=Low(Choises) to High(Choises) do
        Items.Add(Choises[I]);
      Text := AValue;
      TabStop := True;
      Visible := True;
      TabOrder := 0;
      SelectAll;
    end;
    if ShowModal = mrOk then
    begin
      AValue := Edit.Text;
      for I:=Low(Choises) to High(Choises) do
      if Edit.Text = Choises[I] then
       Isinlist:=True;
      Result := True;
    end;
  finally
    Form.Free;
  end;
end;

function InputInt(const ACaption, APrompt: string;
  var AValue: Integer; const Min, Max: Integer): Boolean;
var
  Form: TForm;
  Edit: TSpinEdit;
begin
  Result := False;
  Form := CreateDialogForm(ACaption, APrompt);
  with Form do
  try
    Edit := TSpinEdit.Create(Form);
    With Edit do begin
      Parent := Form;
      Left := (7*AVG.X) div 4;
      Top := (19*AVG.Y) div 8;
      Width := (160*AVG.X) div 4;
      Height := (7*AVG.Y) div 4;
      MinValue := Min;
      MaxValue := Max;
      Value := AValue;
      Increment := 1;

      TabStop := True;
      Visible := True;
      TabOrder := 0;
      SelectAll;
    end;
    Result:=(ShowModal = mrOk);
    if Result then AValue := Edit.Value;
  finally
    Form.Free;
  end;
end;

function InputBool(const ACaption, APrompt: string;
  var AValue: Boolean): Boolean;
var
  Form: TForm;
  Edit: TCheckBox;
begin
  Result := False;
  Form := CreateDialogForm(ACaption, '');// do not use APrompt because of CheckBox.Caption
  with Form do
  try
    Edit := TCheckBox.Create(Form);
    with Edit do
    begin
      Parent := Form;
      Caption := APrompt;
      Left := (7*AVG.X) div 4;
      Top := (19*AVG.Y) div 8;
      Width := (160*AVG.X) div 4;
      Height := (7*AVG.Y) div 4;
      Checked := AValue;

      TabStop := True;
      Enabled := True;
      Visible := True;
      TabOrder := 0;
    end;
    Result := (ShowModal = mrOk);
    if Result then AValue := Edit.Checked;
  finally
    Form.Free;
  end;
end;

function InputQueryScr(const ACaption, APrompt : String; MaskInput : Boolean; var Value : String) : Boolean;
begin
  Result:=InputQuery(ACaption, APrompt, MaskInput, Value);
end;

function Randoms(min, max: Integer): Integer;
begin
  Result:=Random(max-min)+min;
end;

function CE(const i: integer): integer;
begin
  Result:=EL_CUSTOM_START+i-1;
end;

function GE(const i: integer): integer;
begin
  Result:=EL_GROUP_START+i-1;
end;

procedure Mess(const S: String);
begin
  Debug(S);
end;

function Its(const i: integer): String;
begin
  Result:=IntToStr(I);
end;

procedure Messi(const S: String; const i: array of integer);
var
  s2: string;
  i2: integer;
begin
  s2:='';
  for i2:=0 to High(I) do s2:=s2 + ', ' + IntToStr(I[i2]);
  if Length(I) >= 1 then Delete(s2, 1, 2);
  Mess(S + ': ' + S2);
end;

function FindCE(const CEname: string): Integer;
begin
  for Result:=EL_CUSTOM_START to EL_CUSTOM_END do
  if element_info[Result].description = CEname then
   Exit;
  Result:=0;
end;

function FindGE(const GEname: string): Integer;
begin
  for Result:=EL_GROUP_START to EL_GROUP_END do
  if element_info[Result].description = GEname then
   Exit;
  Result:=0;
end;

function LoadLevel(const LevelNumber: Integer; var level: LevelInfo; var elements: eleminfoarr): Boolean;
begin
  setLevelInfoToDefaults(@level, elements);
  Result:=LoadLevelFromFileInfo_RND(@level, elements,
   ExtractFilePath(AMain.LevelFile.FileName) + IntToStrLen(LevelNumber, 3) + '.level');
end;

function IfThenScript(val:boolean; const iftrue, iffalse:integer): integer;
begin
  Result:=ifthen(val, iftrue, iffalse);
end;

function IntPowerScript(base: extended; const exponent : Integer): extended;
begin
  Result:=intpower(base, exponent);
end;

procedure ShowMessageScr(const aMsg: string);
begin
  if CommandLineMode then Debug(aMsg)
  else ShowMessage(aMsg);
end;

type
  ElementCount = packed record
    element, count: integer;
  end;
  ElementCountArray = array of ElementCount;

procedure CountElements(var Result: ElementCountArray; level: LevelInfo; countsort, descendingorder: boolean);
var
  X, Y, I: Integer;
  Found: Boolean;
  Tmp: ElementCount;
begin
  SetLength(Result, 0);
  for X:=0 to level.fieldx - 1 do
  for Y:=0 to level.fieldy - 1 do
  begin
    Found:=False;
    for I:=0 to High(Result) do
    if Result[I].element = level.field[X][Y] then
    begin
      Result[I].count:=Result[I].count + 1;
      Found:=True;
    end;
    if not Found then
    begin
      SetLength(Result, Length(Result) + 1);
      Result[High(Result)].element:=level.field[X][Y];
      Result[High(Result)].count:=1;
    end;
  end;
  SetLength(Result, Length(Result) + 1);// for some unknown reason the script seems to ignore the last record in the array, therefore set it to one more than needed
  repeat
    Found:=False;
    for I:=0 to High(Result)-2 do
    begin
      Y:=IfThen(countsort, Result[I].count, Result[I].element);
      X:=IfThen(countsort, Result[I+1].count, Result[I+1].element);
      if ((X > Y) and (descendingorder)) or ((X < Y) and (not descendingorder)) then
      begin
        Found:=True;
        Tmp:=Result[I];
        Result[I]:=Result[I+1];
        Result[I+1]:=Tmp;
      end;
    end;
  until not Found;
end;

procedure SetElement(element: integer; hexdata: string);
(* SetElement properties from hexdata string - useful for fast manipulation *)
var
  ei: pElementInfo;
  change: pElementChangeInfo;
  x: integer;
begin
  element:=getMappedElement(element);
  ei:=@elements1[element];
  ei^.modified_settings := true;
  xx_ei:= ei^;
  x:=ei^.num_change_pages;
  while (Length(hexdata) > 0) do
  begin
    if Copy(hexdata, 1, 2) = '09' then
    begin// read num_change_page
      hexdata:=SetLevel_MicroChunk(hexdata,chunk_config_CUSX_base,-1,element);
      break;// stop if loaded all base values, continue with change pages
    end
    else hexdata:=SetLevel_MicroChunk(hexdata,chunk_config_CUSX_base,-1,element);
  end;
  ei^:=xx_ei;
  setElementChangePages(ei,ei^.num_change_pages);
  (* initialize number of change pages stored for this custom element *)
  xx_current_change_page:= 0; (* start with reading properties for the first change page *)
  while Length(hexdata) > 0 do
  begin
    change:=@ei^.change_page[xx_current_change_page];// refresh change page in case of a xx_current_change_page change in micro chunk
    xx_change:=change^;
    resetEventBits();
    (* copy change data into temporary buffer *)
    hexdata:=SetLevel_MicroChunk(hexdata,chunk_config_CUSX_change,-1,element);
    change^:=xx_change;
    setEventFlagsFromEventBits(change);
    (* reset bits; change page might have changed *)
  end;
end;

function MD5Script(data: string): string;
begin
  Result:=MD5Print(MD5String(data));
end;

function IntToHexScript(Value: integer; Digits: integer): string;
begin
  Result:=IntToHex(Value, Digits);
end;

procedure Script_OnUses;
const
  MAX_PLAYERS = 4;
begin
  with AMain.PS do
  begin
    {* CONSTANTS *}
    Comp.AddConstantN('MAX_ELEMENT_CONTENTS', 'Byte').SetInt(MAX_ELEMENT_CONTENTS);
    Comp.AddConstantN('MAX_ENVELOPE_XSIZE', 'Byte').SetInt(MAX_ENVELOPE_XSIZE);
    Comp.AddConstantN('MAX_ENVELOPE_YSIZE', 'Byte').SetInt(MAX_ENVELOPE_YSIZE);
    Comp.AddConstantN('MAX_ENVELOPE_TEXT_LEN', 'Word').SetInt(MAX_ENVELOPE_TEXT_LEN);
    Comp.AddConstantN('MAX_LEVEL_NAME_LEN', 'Byte').SetInt(MAX_LEVEL_NAME_LEN);
    Comp.AddConstantN('MAX_LEVEL_AUTHOR_LEN', 'Byte').SetInt(MAX_LEVEL_AUTHOR_LEN);
    Comp.AddConstantN('NUM_ENVELOPES', 'Byte').SetInt(NUM_ENVELOPES);
    Comp.AddConstantN('LEVEL_SCORE_ELEMENTS', 'Byte').SetInt(LEVEL_SCORE_ELEMENTS);
    Comp.AddConstantN('MAX_PLAYERS', 'Byte').SetInt(MAX_PLAYERS);
    Comp.AddConstantN('MAX_ANDROID_ELEMENTS', 'Byte').SetInt(MAX_ANDROID_ELEMENTS);
    Comp.AddConstantN('MAX_PLAYFIELD_WIDTH', 'Byte').SetInt(MAX_PLAYFIELD_WIDTH);
    Comp.AddConstantN('MAX_PLAYFIELD_HEIGHT', 'Byte').SetInt(MAX_PLAYFIELD_HEIGHT);
    Comp.AddConstantN('MAX_LEV_FIELDX', 'Byte').SetInt(MAX_LEV_FIELDX);
    Comp.AddConstantN('MAX_LEV_FIELDY', 'Byte').SetInt(MAX_LEV_FIELDY);
    Comp.AddConstantN('MAX_CHANGE_PAGES', 'Byte').SetInt(MAX_CHANGE_PAGES);
    Comp.AddConstantN('NUM_CHANGE_EVENTS', 'Byte').SetInt(NUM_CHANGE_EVENTS);
    Comp.AddConstantN('MAX_ELEMENTS_IN_GROUP', 'Byte').SetInt(MAX_ELEMENTS_IN_GROUP);
    Comp.AddConstantN('NUM_FILE_ELEMENTS', 'Word').SetInt(NUM_FILE_ELEMENTS);
    Comp.AddConstantN('MAX_ELEMENT_NAME_LEN', 'Byte').SetInt(MAX_ELEMENT_NAME_LEN);
    Comp.AddConstantN('NUM_ELEMENT_PROPERTIES', 'Byte').SetInt(NUM_ELEMENT_PROPERTIES);
    Comp.AddConstantN('NUM_EP_BITFIELDS', 'Byte').SetInt(NUM_EP_BITFIELDS);
    Comp.AddConstantN('MAX_NUM_ELEMENTS', 'Word').SetInt(MAX_NUM_ELEMENTS);
    Comp.AddConstantN('LEVELNUMBER', 'Word').SetInt(CurrentLevelNumber);
    Comp.AddConstantN('FILENAME', 'String').SetString(AMain.LevelFile.FileName);
    Comp.AddConstantN('PROCESSING', 'Boolean').SetInt(Integer(Processing));

    {* TYPES *}
    Comp.AddTypeS('TContent', 'record e: array [0..2] of array [0..2] of integer; end;').ExportName:=true;
    Comp.AddTypeS('TContentArr', 'array [0..MAX_ELEMENT_CONTENTS-1] of TContent;').ExportName:=true;
    Comp.AddTypeS('PContentArr', 'longword').ExportName:=true;
    Comp.AddTypeS('EnvelopeInfo' ,'record xsize: integer; ysize: integer; text: string; end;').ExportName:=true;
    Comp.AddTypeS('pLevelFileInfo', 'longword;').ExportName:=true;
    Comp.AddTypeS('LevelFileInfo', 'record nr: integer; typea: integer; packeda: boolean; basename: pchar; filename: pchar; end;').ExportName:=true;
    Comp.AddTypeS('DateInfo', 'record year: integer; month: integer; day: integer; end;').ExportName:=true;
    Comp.AddTypeS('pLevelInfo', 'longword').ExportName:=true;
    Comp.AddTypeS('LevelInfo', 'record file_info: LevelFileInfo; game_engine_type: integer; file_version: integer; game_version: integer; creation_date: DateInfo; encoding_16bit_field: boolean; encoding_16bit_yamyam: boolean; '+
'encoding_16bit_amoeba: boolean; fieldx: integer; fieldy: integer; time: integer; gems_needed: integer; name: string; author: string;'+
'envelope: array [0..NUM_ENVELOPES-1] of EnvelopeInfo; score: array [0..LEVEL_SCORE_ELEMENTS-1] of integer;'+
'yamyam_content: TContentArr; num_yamyam_contents: integer; amoeba_speed: integer; amoeba_content: integer; game_of_life: array [0..3] of integer; biomaze: array [0..3] of integer;'+
'time_magic_wall: integer; time_wheel: integer; time_light: integer; time_timegate: integer; shield_normal_time: integer; shield_deadly_time: integer; extra_time: integer; time_orb_time: integer; extra_time_score: integer;'+
'start_element: array [0..MAX_PLAYERS-1] of integer; use_start_element: array [0..MAX_PLAYERS-1] of boolean; artwork_element: array [0..MAX_PLAYERS-1] of integer; use_artwork_element: array [0..MAX_PLAYERS-1] of boolean;'+
'explosion_element: array [0..MAX_PLAYERS-1] of integer; use_explosion_element: array [0..MAX_PLAYERS-1] of boolean;'+
'android_move_time: integer; android_clone_time: integer; ball_random: boolean; ball_state_initial: boolean; ball_time: integer; lenses_score: integer; magnify_score: integer; slurp_score: integer;'+
'lenses_time: integer; magnify_time: integer; wind_direction_initial: integer; ball_content: TContentArr; num_ball_contents: integer; num_android_clone_elements: integer;'+
'android_clone_element: array [0..MAX_ANDROID_ELEMENTS-1] of integer; can_move_into_acid_bits: integer;'+
'dont_collide_with_bits: integer; initial_player_stepsize: array [0..MAX_PLAYERS-1] of integer; initial_player_gravity: array [0..MAX_PLAYERS-1] of boolean; em_slippery_gems: boolean; use_spring_bug: boolean; use_time_orb_bug: boolean;'+
'instant_relocation: boolean; can_pass_to_walkable: boolean; grow_into_diggable: boolean; continuous_snapping: boolean; block_snap_field: boolean; block_last_field: boolean; sp_block_last_field: boolean;'+
'use_step_counter: integer; field: array [0..MAX_LEV_FIELDX-1] of array [0..MAX_LEV_FIELDY-1] of word; use_custom_template: boolean; no_valid_file: boolean; changed: boolean; end;').ExportName:=true;
    Comp.AddTypeS('ElementChangeInfo', 'record can_change: boolean; has_event: array [0..NUM_CHANGE_EVENTS-1] of boolean; trigger_player: integer; trigger_side: integer; trigger_page: longword; '
+'target_element: integer; delay_fixed: integer; delay_random: integer; delay_frames: integer;'
+'trigger_element: integer; target_content: TContent; use_target_content: boolean; only_if_complete: boolean; use_random_replace: boolean;'
+'random_percentage: integer; replace_when: integer; explode: boolean; has_action: boolean; action_type: integer; action_mode: integer; action_arg: integer; end;').ExportName:=true;
    Comp.AddTypeS('pElementChangeInfo', 'longword;').ExportName:=true;
    Comp.AddTypeS('ElementGroupInfo', 'record num_elements: integer; element: array [0..MAX_ELEMENTS_IN_GROUP-1] of integer; choice_mode: integer; num_elements_resolved: integer; element_resolved: array [0..NUM_FILE_ELEMENTS-1] of smallint; choice_pos: integer; end;').ExportName:=true;
    Comp.AddTypeS('pElementGroupInfo', 'longword;').ExportName:=true;
    Comp.AddTypeS('ElementNameInfo', 'record token_name: pchar; class_name: pchar; editor_description: pchar; end;').ExportName:=true;
    Comp.AddTypeS('pElementInfo', 'longword;').ExportName:=true;
    Comp.AddTypeS('ElementInfo', 'record token_name: pchar; class_name: pchar; editor_description: string; custom_description: string; description: string; properties: array [0..NUM_EP_BITFIELDS-1] of Longword;'
+'use_gfx_element: boolean; gfx_element: integer; access_direction: integer; collect_score_initial: integer; collect_count_initial: integer; ce_value_fixed_initial: integer; ce_value_random_initial: integer;'
+'use_last_ce_value: boolean; push_delay_fixed: integer; push_delay_random: integer; drop_delay_fixed: integer; drop_delay_random: integer; move_delay_fixed: integer; move_delay_random: integer; move_pattern: integer; '
+'move_direction_initial: integer; move_stepsize: integer; move_enter_element: integer; move_leave_element: integer; move_leave_type: integer; slippery_type: integer; content: TContent; explosion_type: integer; explosion_delay: integer;'
+'ignition_delay: integer; change_page: array [0..MAX_CHANGE_PAGES] of ElementChangeInfo; change: pElementChangeInfo; num_change_pages: shortint; current_change_page: integer;'
+'group: ElementGroupInfo; has_change_event: array [0..NUM_CHANGE_EVENTS-1] of boolean; event_page_nr: array [0..NUM_CHANGE_EVENTS-1] of integer; access_type: integer; access_layer: integer; access_protected: integer; walk_to_action: integer;'
+'smash_targets: integer; deadliness: integer; can_explode_by_fire: boolean; can_explode_smashed: boolean; can_explode_impact: boolean; modified_settings: boolean; end;').ExportName:=true;
    Comp.AddTypeS('ElemInfoArr', 'array [0..MAX_NUM_ELEMENTS] of ElementInfo;').ExportName:=true;

{
    Comp.AddTypeS('LevelFileConfigInfo', 'record element, save_type, data_type, conf_type: integer;'
+'value: longword; default_value: int64; value_copy: longword; num_entities: longword;'
+'default_num_entities: integer; max_num_entities: integer; default_string: longword; end;').ExportName:=true;
    Comp.AddTypeS('LevelFileConfigInfoArray', 'array of LevelFileConfigInfo;').ExportName:=true;
}

    (* NON RND-SOURCE TYPES *)
    Comp.AddTypeS('ElementCount', 'record element, count: integer; end;').ExportName:=true;
    Comp.AddTypeS('ElementCountArray', 'array of ElementCount;').ExportName:=true;

    {* FUNCTIONS *}
    AddFunction(@Mess, 'procedure Mess(const S: string);');
//    AddFunction(@Its, 'function Its(const i: integer): String;');
//    AddFunction(@IntToStrLen, 'function IntToStrLen(const I: Integer; const Len: Integer): String;');
    AddFunction(@Messi, 'procedure Messi(const S: String; const i: array of integer);');
    AddFunction(@CE, 'function CE(const i: integer): integer;');
    AddFunction(@GE, 'function GE(const i: integer): integer;');
    AddFunction(@EnsureRange, 'function EnsureRange(const AValue, AMin, AMax: Integer): Integer;');
    AddFunction(@InRange, 'function InRange(const AValue, AMin, AMax: Integer): Boolean;');
    AddFunction(@Min, 'function Min(a, b: Integer): Integer;');
    AddFunction(@Max, 'function Max(a, b: Integer): Integer;');
    AddFunction(@Randoms, 'function Random(min, max: Integer): Integer;');

    AddFunction(@MinIntValue, 'function MinIntValue(const Data: array of Integer): Integer;');
    AddFunction(@MaxIntValue, 'function MaxIntValue(const Data: array of Integer): Integer;');
    AddFunction(@FindCE, 'function FindCE(const CEname: string): Integer;');
    AddFunction(@FindGE, 'function FindGE(const GEname: string): Integer;');
    AddFunction(@LoadLevel, 'function LoadLevel(const LevelNumber: Integer; var level: LevelInfo; var elements: ElemInfoArr): Boolean;');
    AddFunction(@SetElementInfoToDefaults, 'procedure ClearElement(var elements: ElemInfoArr; element: integer);');
    AddFunction(@IfThenScript, 'function IfThen(val:boolean; const iftrue, iffalse:integer): integer;');
    AddFunction(@IntPowerScript, 'function IntPower(base: extended; const exponent : Integer): extended;');
//zz    AddFunction(@SetLevel_MicroChunk, 'function SetLevel_MicroChunk(hexdata: string; const conf: array of LevelFileConfigInfo;  element: integer;  real_element: integer): integer;');
//zz SetLevel_MicroChunk should be used through SetElement, since xx_ei and stuff aren't avalible in script
//zz    AddFunction(@GetMicroChunk, );
    AddFunction(@SetElement, 'procedure SetElement(element: integer; hexdata: string);');
//    AddFunction(@MD5Script, 'function MD5(data: string): string;');
//    AddFunction(@IntToHexScript, 'function IntToHex(Value: integer; Digits: integer): string;');
    AddFunction(@InputInt, 'function InputInt(const ACaption, APrompt: string;'+
' var AValue: Integer; const Min, Max: Integer): Boolean;');
    AddFunction(@InputQueryScr, 'function InputQuery(const ACaption, APrompt : String; MaskInput : Boolean; var Value : String) : Boolean;');
    AddFunction(@InputBool, 'function InputBool(const ACaption, APrompt: string; var AValue: Boolean): Boolean;');
//zz    AddFunction(@InputChoice, 'function InputChoice(const ACaption, APrompt: string; var AValue: String; Choises: array of string; var Isinlist: Boolean): Boolean;');
                   (* SIGSEGV when adding Choices to Combobox *)
    AddFunction(@ShowMessageScr, 'procedure Alert(const aMsg: string);');

//    AddFunction(@, );

    (* NON RND-SOURCE FUNCTIONS *)
    AddFunction(@CountElements, 'procedure CountElements(var Result: ElementCountArray; level: LevelInfo; countsort, descendingorder: boolean);');

    {* VARIABLES *}
    AddRegisteredPTRVariable('level', 'LevelInfo');
    AddRegisteredPTRVariable('element_info', 'ElemInfoArr');
{
    AddRegisteredPTRVariable('chunk_config_CONF', 'LevelFileConfigInfoArray');
    AddRegisteredPTRVariable('chunk_config_CUSX_base', 'LevelFileConfigInfoArray');
    AddRegisteredPTRVariable('chunk_config_CUSX_change', 'LevelFileConfigInfoArray');
    AddRegisteredPTRVariable('chunk_config_ELEM', 'LevelFileConfigInfoArray');
    AddRegisteredPTRVariable('chunk_config_GRPX', 'LevelFileConfigInfoArray');
    AddRegisteredPTRVariable('chunk_config_INFO', 'LevelFileConfigInfoArray');
    AddRegisteredPTRVariable('chunk_config_NOTE', 'LevelFileConfigInfoArray');
}
//    AMain.CE.AddRegisteredVariable('varname','String');
  end;
end;

end.

